// Program TC014.cpp
//---------------------------------------------------------------------
// Vektor elemek ciklikus lptetse (krforg puffer hasznlata).
// (rtk- s cmparamterek, globlis konstans s tpus alkalmazsa)
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok                            
//..............................................................
#include <iostream.h>   // cin, cout                            
#include <math.h>       // floor, abs                           
#include <ctype.h>      // toupper
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int       VHOSSZ = 5;             // A vektormret definilsa
typedef char    vektortipus[VHOSSZ];    // A vektortpus definilsa
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)           
//......................................................
//void main();
    void feltolt(vektortipus&);
    void kiir(vektortipus&);
    void forgatkiir(vektortipus&);
      int lepeskerdes();
      void forgat(int, vektortipus&);
        void pozitivforgatas(int, vektortipus&);
        void negativforgatas(int, vektortipus&);
//        void pozitivforgatas(int, vektortipus&);
//    void kiir(vektortipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void feltolt(vektortipus&   avektor)
// Vektorfeltlts 
{
  int       index;
  for (index = 0; index <= (VHOSSZ-1); index++)
     {
      cout << "A vektor " << index << "-ik karaktere: ";
      cin >> avektor[index];
     }
  cout << endl;
} // Feltolt

void kiir(vektortipus&   hvektor)
// A vektor kiratsa
{
  int       index;
  for (index = 0; index <= (VHOSSZ-1); index++)
    cout << hvektor[index];
  cout << endl;
} // Kiir

int lepeskerdes()
{
  int       valasz ;
  cout << "Mennyit lptet?  ";
  cout << "(pozitv-negatv szmot egyarnt megadhat) : ";
  cin >> valasz;
  return valasz ;
} // lepeskerdes

void pozitivforgatas(int            lepes,
		     vektortipus&   dvektor)
{
  int       lindex, index;
  char      atmenet;
  for (lindex = 1; lindex <= lepes; lindex++)
    {
     atmenet = dvektor[VHOSSZ-1];
     for (index = (VHOSSZ-1); index >= 1; index--)
       dvektor[index] = dvektor[index-1];
     dvektor[0] = atmenet;
    }
} // pozitivforgatas

void negativforgatas(int            lepes,
		     vektortipus&   evektor)
{
  pozitivforgatas(VHOSSZ-lepes, evektor);
} // negativforgatas

void forgat(int            lepesszam,
	    vektortipus&   cvektor)
{
  if (lepesszam >= 0)
    pozitivforgatas(lepesszam, cvektor);
  else
    negativforgatas(abs(lepesszam), cvektor);
} //  forgat

void forgatkiir(vektortipus&   bvektor)
{
  char      folytatja;
  int       lepesszam;
  do {
      lepesszam = lepeskerdes() % VHOSSZ;
      // ahol % a maradkkpzs jele, azaz
      // a % b = a - b * floor(a/b)
      forgat(lepesszam, bvektor);
      kiir(bvektor);
      do {
	  cout << "Folytatja? (I/N) : ";
	  cin >> folytatja;
	  folytatja = toupper(folytatja);
	 } while(!(folytatja == 'I' || folytatja == 'N'));
     } while (folytatja != 'N');
} // forgatkiir

/**********/
void main()
/**********/
{
  vektortipus     xvektor;

  //  Vektorfeltlts
  feltolt(xvektor);

  // A bert vektor kiratsa
  kiir(xvektor);

  // A vektor ciklikus lptetse (forgatsa), s kiiratsa
  forgatkiir(xvektor);
}

/*
A program futtatsa:
--------------------

A vektor 1-ik karaktere: U
A vektor 2-ik karaktere: V
A vektor 3-ik karaktere: W
A vektor 4-ik karaktere: X
A vektor 5-ik karaktere: Y
UVWXY
Mennyit lptet? (pozitv-negatv szmot egyarnt megadhat) : 3
WXYUV
Folytatja? (I/N) : i
Mennyit lptet? (pozitv-negatv szmot egyarnt megadhat) : -8
UVWXY
Folytatja? (I/N) : n
*/
