// Program TC018.cpp
//----------------------------------------------------------------------
// Adott n pozitv egsz szm faktorilisnak meghatrozsa             
// Megjegyzs:                                                          
// 1. A program elzetes vizsglattal kizrja az illeglis rtkmegadst
// 2. A program a szemllteti                                           
//    2.1. a rekurzv fggvnyhvst,                                   
//    2.2. a kiszmtst itercival,                                   
//    2.3. az iterci s a rekurzi futsi-eredmny ekvivalencijt,   
//    2.4. az iterci s a rekurzi erforrs-igny klnbsgt.       
//----------------------------------------------------------------------
// A matematikai modell:                                                
// n! = 1 * 2 * ... * (n-1) * n                                         
//----------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <ctype.h>      // toupper
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int    MAX = 13; // Ennl nagyobb n esetn a faktorilis  eredmny
                       // kikerlne az engedlyezett tartomnybl.
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)
//......................................................
//void main();
    void nbekerese(int&);
    char modszer();
    long int ifaktorialis(int);
    long int rfaktorialis(int);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void nbekerese(int& n)
//----------------------------------------------------------------------
// Az n egszszm bekrse vizsglattal
//----------------------------------------------------------------------
{ 
  cout << "Az n egsz szm faktorilisnak meghatrozsa ";
  cout << "(0 < n  " << MAX << ")\n";
  do {
      cout << "n : "; cin >> n;
     } while (!(n > 0 && n <= MAX));
}  // nbekerese eljrs 

char modszer()
//----------------------------------------------------------------------
// Programozstechnikai mdszer vlaszts                               
// (A matematikai modell ugyanaz)                                       
// 'I' : A szmtsi eljrs itercis                                  
// 'R' : A szmtsi eljrs rekurzv                                   
//----------------------------------------------------------------------
{
  char    valasz;
  
  do {
      cout << "A kiszmtsi eljrs (I)tercis, vagy (R)ekurzv : ";
      cin >> valasz;
      valasz = toupper(valasz);
     } while (valasz != 'I' && valasz != 'R');
  return  valasz;
}  // modszer

long int ifaktorialis(int n)
//----------------------------------------------------------------------
// Az n faktorilisnak meghatrozsa itercival.                      
//----------------------------------------------------------------------
{
  int          index;
  long int     munka;

  munka = 1;
  for (index = 2; index <= n; index++)
     munka = index * munka;
  return  munka;
}  // ifaktorialis

long int rfaktorialis(int n)
//----------------------------------------------------------------------
// Az n faktorilisnak meghatrozsa rekurzv fggvnyhvssal.
//----------------------------------------------------------------------
{
  if (n == 1)
    return  1;
  else
    return  n * rfaktorialis(n-1);
}  // rfaktorialis 

/**********/
void main()
/**********/
{
  int        n;
  long int   faktorialis;  
             // A long int 32 bites eljeles fixpontos tpus.
             // rtktartomnya: -2^31...+2^31-1.           

  // Adatbekrs rtkvizsglattal 
  nbekerese(n);

  // Mdszervlaszts 
  if (modszer() == 'I')
    // Itercis mdszer
    faktorialis = ifaktorialis(n);
  else
    // Rekurzis mdszer 
    faktorialis = rfaktorialis(n);

  // Az eredmny kiiratsa 
  cout << n << "! = " << faktorialis << "\n";
}

/*
A program futtatsa:
--------------------

n egsz szm faktorilisnak meghatrozsa (0 < n  13).
n : 13
A kiszmtsi eljrs (i)tercis, vagy (r)ekurzv : r
13! = 1932053504
*/
