// Program TC019.cpp                                                    
//----------------------------------------------------------------------
// Az n-ik Fibonacci szm meghatrozsa                                 
// Megjegyzs:                                                          
// 1. A program elzetes vizsglattal kizrja az illeglis rtkmegadst
// 2. A program a szemllteti                                           
//    2.1. a tbbszrs rekurzv fggvnyhvst,                        
//    2.2. a kiszmtst itercival,                                   
//    2.3. az iterci s a rekurzi futsi-eredmny ekvivalencijt,   
//    2.4. az iterci s a rekurzi erforrs-igny klnbsgt.       
//----------------------------------------------------------------------
// A matematikai modell:                                                
// F(0) = 0                                                             
// F(1) = 1                                                             
// F(N) = F(N-1) + F(N-2)                                               
//----------------------------------------------------------------------
// Az utols javts dtuma: 2000.03.16.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <ctype.h>      // toupper
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int    MAX = 46;   // Ennl nagyobb n esetn a Fibonacci szm
                         // kikerlne az engedlyezett tartomnybl.
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)
//......................................................
//void main();
    void nbekerese(int&);
    char modszer();
    long int ifibonacci(int);
    long int rfibonacci(int);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void nbekerese(int& n)
//----------------------------------------------------------------------
// Az n egszszm bekrse vizsglattal
//----------------------------------------------------------------------
{ 
  cout << "Az n-edik Fibonacci szm generlsa ";
  cout << "(0 < n  " << MAX << ")\n";
  do {
      cout << "n : "; cin >> n;
     } while (!(n > 0 && n <= MAX));
}  // nbekerese eljrs 

char modszer()
//----------------------------------------------------------------------
// Programozstechnikai mdszer vlaszts                               
// (A matematikai modell ugyanaz)                                       
// 'I' : A szmtsi eljrs itercis                                  
// 'R' : A szmtsi eljrs rekurzv                                   
//----------------------------------------------------------------------
{
  char    valasz;
  
  do {
      cout << "A kiszmtsi eljrs (I)tercis, vagy (R)ekurzv : ";
      cin >> valasz;
      valasz = toupper(valasz);
     } while (valasz != 'I' && valasz != 'R');
  return  valasz;
}  // modszer

long int ifibonacci(int n)
//----------------------------------------------------------------------
// Az n-ik Fibonacci szm ellltsa itercival
//----------------------------------------------------------------------
{
  long int     munkan, munkan_1, munkan_2 ;
  int          index  ;

  if (n == 0 )
    return  0 ;
  else
    if (n == 1 )
      return  1;
    else
      {
       munkan_2 = 0;  // n = 0 
       munkan_1 = 1;  // n = 1
       for (index = 2; index <= n; index++)
	 {
	  munkan   = munkan_1 + munkan_2;
	  munkan_2 = munkan_1;
	  munkan_1 = munkan;
	 }
       return  munkan;
      }
}  // ifibonacci

long int rfibonacci(int n)
//----------------------------------------------------------------------
// Az n-ik Fibonacci szm ellltsa rekurzv fggvnyhvssal
//----------------------------------------------------------------------
{
  if (n == 0)
    return  0 ;
   else
     if (n == 1 )
       return  1 ;
     else
       return rfibonacci(n-1) + rfibonacci(n-2);
}  // rfibonacci

/**********/
void main()
/**********/
{
  int        n;
  long int   fibonacci;  
             // A long int 32 bites eljeles fixpontos tpus.
             // rtktartomnya: -2^31...+2^31-1.           

  // Adatbekrs rtkvizsglattal 
  nbekerese(n);

  // Mdszervlaszts 
  if (modszer() == 'I')
    // Itercis mdszer
    fibonacci = ifibonacci(n);
  else
    // Rekurzis mdszer 
    fibonacci = rfibonacci(n);

  // Az eredmny kiiratsa 
  cout << "A(z) " << n << "-ik Fibonacci szm : " << fibonacci << "\n";
}

/*
A program futtatsa:
--------------------

Az n-ik Fibonacci szm generlsa (0 < n  46).
n : 46
A kiszmtsi eljrs (I)tercis, vagy (R)ekurzv : i
A(z) 46-ik Fibonacci szm : 1836311903
*/
