// Program TC022.cpp
//------------------------------------------------------------------------
// Tmbelemek sztvlogatsa kt msik tmbbe adott T tulajdonsg szerint,
// ahol T: a felhasznl ltal megadott szmmal val oszthatsg.
//------------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.15.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setw, setiosflag
//--------------------------------------------------------------


//----------------------------------------
// Globlis azonostk                  
//........................................
const    int       MAXTOMB = 20;          // A maximlis tmbmret
typedef  struct    { int  tomb[MAXTOMB];  // A tmb tagja, s
                     int  meret;          // a tnyleges mret tagja
                   } tombtipus;           // a tmbtpusnak
//----------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok modell)
//......................................................
//void main();
    void meret(tombtipus&);
    void beolvas(tombtipus&);
    void oszto_bekeres(int&);
    void init(tombtipus&);
    void szetrak(int, tombtipus&, tombtipus&, tombtipus&);
      char eldont(int, int);
      void pakol(int, tombtipus&);
    void kiir(tombtipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void meret(tombtipus&   adat)
// Az eredeti_tomb szksges mrett kri be a felhasznltl
{
  int   egesz;
  cout << "\nAdatbevitel a felhasznli tmbbe: \n\n";
  do { cout << "Az elemek szma (legfeljebb " << MAXTOMB << ") : ";
       cin >> egesz;
     } while (egesz <= 0  ||  egesz > MAXTOMB);
  adat.meret = egesz;
} //meret

void beolvas(tombtipus&   adat)
// A paramter-struktra tmb tagjnak felhasznl ltal
// trtn feltltse e struktrban megadott mretben
{
  int   i;
  cout << "Adja meg a tmb elemeit! \n";
  for(i = 0; i <= (adat.meret-1); i++)
    { cout << "A tmb " << i << "-edik eleme : ";
      cin >> adat.tomb[i];
    }
  cout << "\n";
} //beolvas


void oszto_bekeres(int&   egesz)
// A T sztvlogatsi tulajdonsg, vagyis az oszto bekrse
{
  cout << "A T sztvlogatsi tulajdonsg ";
  cout << "az n ltal adott szmmal val oszthatsg, \n";
  cout << "ahol az oszt: ";
  cin >> egesz;
} //oszto_bekeres

void init(tombtipus&   egyik)
// A paramter-struktra mret tagjnak inicializlsa
{
  egyik.meret = 0;
} //init

char eldont(int    egy_elem, 
            int    szam)
// Az els paramternek a msodik paramterrel val oszthatsgt 
// vizsglja
{
  if ((egy_elem % szam) == 0)
    return 'I';
  else
    return 'N';
} //eldont

void pakol(int          egy_elem,
           tombtipus&   egyik)
// A paramter-struktra tmb tagjhoz hozzfzi a msik paramterknt
// megadott elemet, s a struktra mret tagjt aktualizlja
{
  egyik.tomb[egyik.meret] = egy_elem;
  egyik.meret++;
} //pakol

void szetrak(int          oszto,     // Az oszt
             tombtipus&   eredeti,   // Az eredeti,
             tombtipus&   jo,        //   az oszthatsgot teljest,
             tombtipus&   nem_jo)    //   s a nem teljest tmb
// Sztvlogats a T tulajdonsg, vagyis az oszto-val val oszthatsg 
// szerint
{
  int     futo_index;       // Az eredeti tmbhz
  for (futo_index = 0; futo_index < eredeti.meret; futo_index++)
    if (eldont(eredeti.tomb[futo_index], oszto) == 'I')
      pakol(eredeti.tomb[futo_index], jo);
    else
      pakol(eredeti.tomb[futo_index], nem_jo);
}

void kiir(tombtipus&   egyik)
// A paramter-struktra tmbelemeinek kiratsa
{
  int   i;
  if (egyik.meret == 0)
    { // Ekkor nincs kirand elem
      cout << " --- nincs elem --- \n\n";
      // Kiugrs a fggvnybl
      return;
    };
  for (i = 0; i < egyik.meret; i++)
     // A kirats mezszlessge: 5,
     // az adatelhelyezs a mezben jobbra tmrtett.
     cout << setw(5) << setiosflags(ios::right) << egyik.tomb[i];
  cout << "\n\n";
} //kiir


/**********/
void main()
/**********/
{
  tombtipus   eredeti,          // A feladat
              megfelelt,        //   hrom
              nem_felelt_meg;   //   adattmbje
  int         oszto;            // A tmbelemek sztvlogatshoz

  // Az eredeti tmb tnyleges mretnek bekrse
  meret(eredeti);

  // Beolvass az eredeti tmbbe   
  beolvas(eredeti);

  // A T sztvlogatsi tulajdonsg, vagyis az oszto bekrse
  oszto_bekeres(oszto);

  // A tulajdonsg tmbk mreteinek inicializlsa
  init(megfelelt);
  init(nem_felelt_meg);

  // Sztvlogats a T tulajdonsg, vagyis
  // az oszto-val val oszthatsg szerint
  szetrak(oszto, eredeti, megfelelt, nem_felelt_meg);

  cout << "Az eredeti tmb elemei :\n";
  kiir(eredeti);

  cout << "A T tulajdosgnak megfelel tomb elemei :\n ";
  kiir(megfelelt);

  cout << "A T tulajdonsgnak nem megfelel tmb elemei :\n";
  kiir(nem_felelt_meg);
} //main

/*
A program futtatsa:
--------------------

Adatbevitel a felhasznli tmbbe:

Az elemek szma (legfeljebb 20) : 5
Adja meg a tmb elemeit!
A tmb 0-edik eleme : 65
A tmb 1-edik eleme : 173
A tmb 2-edik eleme : -42
A tmb 3-edik eleme : 0
A tmb 4-edik eleme : -5

A T sztvlogatsi tulajdonsg az n ltal adott szmmal val oszthatsg,
ahol az oszt: 5
Az eredeti tmb elemei :
   65  173  -42    0   -5

A T tulajdosgnak megfelel tomb elemei :
   65    0   -5

A T tulajdonsgnak nem megfelel tmb elemei :
  173  -42
*/