// Program TC054.cpp
//---------------------------------------------------------------------
// Objektumhasznlat
// Osztly tpus objektum kls metdussal,
// s paramter-alaprtelmezst tartalmaz kls konstruktorral
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.09.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy
#include <conio.h>      // clrscr
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
class dolgozo
// Ez egy osztly-tpus kls metdussal, s kls konstruktorral
{
  private:
    // A privt tagok csak ebben az osztlyban lthatk
    // Alaprtelmezs - a "private" cmke elhagyhat
    typedef char     nev_tipus[20];  // Adattag (tpus)

  public:
    // A nyilvnos tagok lthatak csak kvlrl is
    nev_tipus        neve;           // Adattag (vltoz)
    long int         azonositoja;    // Adattag (vltoz)
    long int         fizetese;       // Adattag (vltoz)

    void adatkiirasa();              // Metdustag prototpusa

    dolgozo(nev_tipus = "",         // Metdustag (konstruktor)
            long int  = 0,          //  prototpusa
            long int  = 0);         //  alaprtelmezsekkel
}; //dolgozo
//--------------------------------------

void dolgozo::adatkiirasa()
// Ez egy kls metdus a "::" hivatkozssal az osztly nevre
{
  cout << "Nv       : " << neve        << endl;      // endl = "\n"
  cout << "Azonost : " << azonositoja << endl;
  cout << "Fizets   : " << fizetese    << endl;
  cout << endl;
} //adatkiirasa

dolgozo::dolgozo(nev_tipus       nev,
                  long int       azonosito,
                  long int       fizetes)
// Ez egy kls konstruktor a "::" hivatkozssal az osztly nevre.
// Ennek a konstruktornak a deklarcijban a paramterek alaprtel-
// mezst kaptak, gy objektum ltrehozskor nincs szksg alibi
// rtkadsra akkor, ha az objektumot nem akarjuk inicializlni.
// A konstruktor fggvny neve megegyezik az objektum-tpus (mely
// ezttal egy osztly-tpus) nevvel.
// A konstruktor fggvnynek nincs tpusa (de a void szt sem kell
// lerni).
// A konstruktor fggvny minden objektumpldny ltrehozsakor
// automatikusan lefut, gy fel tudjuk hasznlni az adattagok
// inicializlsra is hasznlhat.
{
  strcpy(neve, nev);
  azonositoja = azonosito;
  fizetese = fizetes;
} //dolgozo::dolgozo

/**********/
void main()
/**********/
{
  // Kpernytrls
  clrscr();

  // Objektum ltrehozs ("deklarcival").
  // Ha egyes pldnyok ltrehozsakor alkalmazzuk a konstruktor
  // fggvnyt, akkor azoknak a konstruktorban kijellt adattagjai
  // egyttal inicializltak lesznek.
  // Ha az objektumban deklarltunk konstruktort,
  // akkor hasznlnunk is kell. Ez esetenknt alibi rtkadst jelent,
  // mely csak az alaprtelmezett argumentum hasznlattal kerlhet el.
  dolgozo       munkas("Kiss Jnos", 123456L, 20000L);
  dolgozo       fonok1("Nagy Pter", 12L, 200000L);
//  dolgozo       fonok2("valaki", 0L, 0L);       // alibi rtkek
  dolgozo       fonok2("");      // alaprtelmezett argumentum hasznlat

  // rtkads a konstruktorral val inicializls sorn mr megtrtnt

  // Objektum rtkads
  fonok2 = fonok1;
  // Kiiratas az objektumok metdusval
  munkas.adatkiirasa();
  fonok1.adatkiirasa();
  fonok2.adatkiirasa();
  // A fonok2 objektum mretnek kiratsa
  cout << sizeof(fonok2) << endl;
} //main
