// Program TC071-2.cpp
//---------------------------------------------------------------------
// Szveges file msolsa soronknt
// (A kimeneti file egyezik a bemenetivel csak nincs a vgn Ctrl-Z)
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.25.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream
#include <iostream.h>   // cin, cout
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXNAME = 20;         // A max. file-nv hossz
const int       LINELGT = 80;         // A max. sor hossz
typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
typedef enum    { iras, olvasas
                }  modtipus;          // file-megnyitsi md tpusa
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    int megnyit( fstream&, ftnev, modtipus );
    void lezar( fstream& );
    void masol( fstream&, fstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

int megnyit( fstream&     adatf,
             ftnev        fnev,
             modtipus     nyitas )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja a "nyitas" szerint rsra vagy olvassra
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 1, vagy 2.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits
  switch ( nyitas )
    { case  iras       : adatf.open( fnev, ios::out ); break;
      case  olvasas    : adatf.open( fnev, ios::in );  break;
    };
  // A megnyits sikeressgnek vizsglata
  if ( ! adatf.fail() )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    switch ( nyitas )
      { case  iras :
          cout << "A kimeneti file megnyitsa nem sikerlt." << endl ;
          return 1;
        case  olvasas :
          cout << "A bemeneti file megnyitsa nem sikerlt." << endl ;
          return 2;
        default :
          // Hibs megnyitsi md hasznlat
          return 999;
      };
} //megnyit


void lezar( fstream&    adatf )
//***********************************************************************
// A paramterknt megadott adatfolyamot lezrja.
//***********************************************************************
{
  // A file lezrsa
  adatf.close();
} //lezar


void masol( fstream&    bemenet,
            fstream&    kimenet )
//***********************************************************************
// Az els paramterknt megadott file-bl beolvas soronknt
// majd a msodik paramterknt megadott file-ba kir.
// Mdszer: 1. Elreolvass, 2. Ciklikus EOFellenrzs-kirs-beolvass
// A felhasznlt globlis azonostk:
//                      LINELGT : egy sor maximlis hossza
//***********************************************************************
{
  char     egysor[ LINELGT ];

  // Elreolvass a bemeneti file-bl (olvassi kisrlet) !!!
  bemenet.getline( egysor, LINELGT );
  // File-vg ellenrzst kvet ciklikus kirs-beolvass
  while ( ! bemenet.eof() )
     { // Kirats a kimeneti file-ba
       kimenet << egysor << endl;
       // Beolvass a bemeneti file-bl
       bemenet.getline( egysor, LINELGT );
     }
} //masol


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      fnev;                // fizikai filenv
  fstream    be_file;             // bemeneti logikai file ltrehozsa
  fstream    ki_file;             // kimeneti logikai file ltrehozsa
  int        hibakod;             // file-megnyitsi hibakd
  modtipus   megnyitasi_mod;      // file-megnyitsi md

  // A BEMENET ELKSZITSE ============================================
  // A bemeneti fizikai file nevnek bekrse
  cout << "Adja meg a bemeneti file nevt az elrsi ttal egytt! ";
  cin  >> fnev;
  // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
  megnyitasi_mod = olvasas;
  hibakod = megnyit( be_file, fnev, megnyitasi_mod );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A KIMENET ELKSZITSE ============================================
  // A kimeneti fizikai file nevnek bekrse
  cout << "Adja meg a kimeneti file nevt az elrsi ttal egytt! ";
  cin  >> fnev;
  // Fizikai file-nv hozzrendels, megnyits rsra, ellenrzs
  megnyitasi_mod = iras;
  hibakod = megnyit( ki_file, fnev, megnyitasi_mod );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A MSOLS =========================================================
  masol( be_file, ki_file );

} //main
