// Program TC071-3.cpp
//---------------------------------------------------------------------
// Szveges file kirsa nyomtatra, kpernyre
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.12.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // ifstream
#include <iostream.h>   // cin, cout
#include <stdlib.h>     // exit
#include <ctype.h>      // toupper
#include <string.h>     // strcpy
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXNAME = 20;         // A max. file-nv hossz
const int       LINELGT = 80;         // A max. sor hossz
typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    void clrbuf();
    int INPmegnyit( ifstream&, ftnev );
    int OUTmegnyit( ofstream&, ftnev );
    void valaszt( ftnev& );
    void lezar( ifstream& );
    void kiir( ifstream&, ofstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()  { while ( cin.get() != '\n' ); }
//*******************************************
// Billentyzetpuffert trl fggvny
//*******************************************


int INPmegnyit( ifstream&     adatf,
                ftnev         fnev )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja olvassra,
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 1.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits
  // Az ifstream tpus file csak olvassra lehet megnyitni,
  // ezrt elhagyhat az "ios::in" megads
  adatf.open( fnev );
  // A megnyits sikeressgnek vizsglata
  // A sikeres megnyits esetn a file-objektum egy logikai IGAZ
  // rtket kap (teht nem csak a fail tagfggvnnyel lehet vizsglni
  // egy megnyits sikeressgt)
  if ( adatf )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    { cout << "A file megnyitsa nem sikerlt." << endl ;
      return 1;
    }
} //INPmegnyit


int OUTmegnyit( ofstream&     eszkoz,
                ftnev         eszkoznev )
//***********************************************************************
// 1. Az "eszkoznev" szabvnyos nev (con /kperny/, prn, lpt1, lpt2
//    /nyomtat/) eszkzhz hozzrendeli az "eszkoz" output adatfolyamot,
// 2. majd ezt megnyitja rsra,
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 2.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits
  // Az ofstream tpus file csak olvassra lehet megnyitni,
  // ezrt elhagyhat az "ios::out" megads
  eszkoz.open( eszkoznev );
  // A megnyits sikeressgnek vizsglata
  if ( eszkoz )
    // Ekkor az eszkz megnyits sikeres
    return 0;
  else
    // Ekkor az eszkz megnyits nem sikeres
    { cout << "A kivlasztott eszkz megnyitsa nem sikerlt." << endl ;
      return 2;
    }
} //OUTmegnyit


void lezar( ifstream&    adatf )
//***********************************************************************
// A paramterknt megadott adatfolyamot lezrja.
//***********************************************************************
{
  // A file lezrsa
  adatf.close();
} //lezar


void valaszt( ftnev&    eszkoznev )
//***********************************************************************
// A kimeneti eszkz kivlasztsa
//***********************************************************************
{
  char     valasz;

  do { cout <<"      Kpernyre, vagy Nyomtatra kri a kirst? (K/N) ";
       cin >> valasz;  clrbuf();
       valasz = toupper(valasz);
     } while ( valasz != 'K' && valasz != 'N' );

  if ( valasz == 'K' )
    // Kperny
    strcpy(eszkoznev, "con");
  else     
    // Nyomtat
    strcpy(eszkoznev, "prn");
} //valaszt


void kiir( ifstream&    bemenet,
           ofstream&    eszkoz )
//***********************************************************************
// A paramterknt megadott file-bl beolvas soronknt
// majd a kijellt eszkzre kir.
// A felhasznlt globlis azonostk:
//                      LINELGT : egy sor maximlis hossza
//***********************************************************************
{
  char     egysor[ LINELGT ];

  // Elreolvass a file-bl (olvassi kisrlet) !!!
  bemenet.getline( egysor, LINELGT );
  // File-vg ellenrzst kvet ciklikus kirs-beolvass
  while ( ! bemenet.eof() )
     { // Kirats a kijellt eszkre
       eszkoz << egysor << endl;
       // Beolvass a file-bl
       bemenet.getline( egysor, LINELGT );
     }
} //kiir


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      fnev;            // A fizikai filenv
  ifstream   be_file;         // A logikai file ltrehozsa
  ftnev      eszkoznev;       // Az output eszkz fizikai fileneve
  ofstream   eszkoz;          // Az output eszkzhz rendelt kimeneti
                              //   adatfolyam ltrehozsa
  int        hibakod;         // A file-megnyitsi hibakd

  // A BEMENET ELKSZITSE ============================================
  // A fizikai file nevnek bekrse
  cout << "Adja meg a file nevt az elrsi ttal egytt! ";
  cin  >> fnev;
  // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
  hibakod = INPmegnyit( be_file, fnev );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A KIMENETI ESZKZ ELKSZITSE ====================================
  // Fizikai eszkznv hozzrendels, megnyits, ellenrzs
  valaszt(eszkoznev);
  hibakod = OUTmegnyit( eszkoz, eszkoznev );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A KIIRS ==========================================================
  kiir( be_file, eszkoz );
  lezar( be_file );

} //main
