// Program TC074.cpp
//---------------------------------------------------------------------
// Binris file-kezels II.
//---------------------------------------------------------------------
// Ksztsen hallgati nyilvntartst, mely a felhasznltl bekri a
// a hallgatok adatait, majd azokat egy, a felhasznl ltal megadott
// nev file-ba menti. Az adatbevitel mindaddig tart, amg a felhasznl
// azt folytatni nem kvnja. Vgl a program listzza ki a file tartal-
// mt a kpernyre.
//.....................................................................
// Lsd e program kibvtett vltozatt (TC079.cpp)!
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.16.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream, open, fail, eof, write, read
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setf, precision
#include <ctype.h>      // toupper
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int           MAXNEV = 20; // A leghosszabb nv hossza + 1

typedef char        fnev_tipus[MAXNEV];
typedef struct      hallgato_tipus
          { char        neve[MAXNEV];
            int         szul_eve;
            float       atlaga;
          }; // hallgato_tipus
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void clrbuf();
    char valasz();
    void beolvas(hallgato_tipus&);
    void kiir(hallgato_tipus&);
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()  { while (cin.get() != '\n'); }

char valasz()
// Folytatsi ignyt bekr fggvny
{
  char    kar;

  do { cout <<"      Folytatja? (I/N) ";  cin >> kar;  clrbuf();
       kar = toupper(kar);
     } while ( kar != 'I' && kar != 'N' );
  return kar;
} //valasz


void beolvas(hallgato_tipus& hallgato)
// Egy hallgat adatainak beolvassa a memriba
{
   cout << "A hallgat neve:              ";
     cin.getline( hallgato.neve, sizeof(hallgato.neve) );
       if( cin.gcount() >= sizeof(hallgato.neve)-1 )     clrbuf();
   cout << "A hallgato szletsi ve:     ";
     cin >> hallgato.szul_eve;                           clrbuf();
   cout << "A hallgat tanulmnyi tlaga: ";
     cin >> hallgato.atlaga;                             clrbuf();
} //beolvas


void kiir(hallgato_tipus& hallgato)
// Egy hallgat adatainak kiirsa a memribl a kpernyre.
{
   cout << "A hallgat neve:         " << hallgato.neve << endl;
   cout << "     szletsi ve:      " << hallgato.szul_eve <<endl;
   cout.setf(ios::fixed);
   cout.precision(2);
   cout.setf(ios::showpoint);
   cout << "     tanulmnyi tlaga:  " << hallgato.atlaga << endl;
} //kiir


/**********/
void main()
/**********/
{
   fnev_tipus      fnev;
   fstream         tankor;  //logikai fajlnev, file-objektum ltrehozsa
   hallgato_tipus  diak;

   // Az adatfile nevnek bekrse
   cout << "Az adatfile neve: ";
   cin >> fnev;    clrbuf();                      // file-nv bekrs
   // strcpy(fnev,"C:\\VILSZAK\\V42-tk.dat");     // file-nv megads

   // Az adatfile megnyitsa kirsra, s a megnyits ellenrzse
   tankor.open( fnev, ios::binary | ios::out );
   if ( tankor.fail() )         // fjl megnyits hibavizsglata
     { cout << "A kimeneti file megnyitsa nem sikerlt" << endl;
       // Sikertelen file-megnyits esetn kiurs a programbl
       // az opercis rendszerbe hibakddal
       exit(1);
     }
   //
   // Adatbeolvass a klaviatrrl, adatkirs a file-ba
   do { // Adatbeolvass a klaviatrrl
        beolvas(diak);
        // Adatkirs a file-ba
        tankor.write( (char*)&diak, sizeof(hallgato_tipus) );
      } while( valasz() != 'N' );
   tankor.close();

   // Az adatfile megnyitsa beolvassra, s a megnyits ellenrzse
   tankor.open( fnev, ios::binary | ios::in );
   if ( ! tankor )              // fjl megnyits hibavizsglata
     { cout << "A bemeneti file megnyitsa nem sikerlt";
       // Sikertelen file-megnyits esetn kiurs a programbl
       // az opercis rendszerbe hibakddal
       exit(2);
     }
   
   // Adatbeolvass a file-bl, adatkirs a kpernyre
   cout << "A(z) " << fnev << " file-beli hallgatk: " << endl;
   //     Elreolvass
   tankor.read( (char*)&diak, sizeof(hallgato_tipus) );
   //     Ciklikus file-vg ellenrzs
   while ( ! tankor.eof() )
     { // Adatfeldolgozs (kirats a kpernyre)
       kiir(diak);
       // Ujraolvass
       tankor.read( (char*)&diak, sizeof(hallgato_tipus) );
       }
   tankor.close();
} //main
