// Program TC077-3.cpp                              (a TC077-1 alapjn)
//---------------------------------------------------------------------
// File msols, nyomtats
//   --> File kezels gyorstsa konstruktorban megadott pufferrel
//   --> Alacsonyszint file-kezels
//.....................................................................
// Hasznlata: tc077-3 <forrs file> <cl file>
// Funkcija:
//    A mr ltez forrs file-t a cl file-ba msolja.
//    Ha a cl file mr ltezik, akkor azt fellrja, ha nem ltezik,
//    akkor pedig ltrehozza (feltve, hogy az lehetsges).
//    Ha a file-knt a con standard file nevet hasznljuk,
//    akkor inputknt a klaviatrt, outputknt a kpernyt jelli ki.
//    Ha szveges file nyomtatsra akarjuk hasznlni,
//    akkor cl file-knt prn-t, lpt1-et, vagy lpt2-t adjunk meg.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.21.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <io.h>         // _open, _creat
#include <errno.h>      // Az errno hibakonstansai
#include <fcntl.h>      // Az _open flag-jei (O_RDONLY, stb.)
#include <iostream.h>   // cin, cout
#include <process.h>    // exit, system
#include <fstream.h>    // ifstream, ofstream
#include <conio.h>      // clrscr
#include <string.h>     // strcmp
//--------------------------------------------------------------


//***********************************************************************
void main( int argc, char* argv[] )
//***********************************************************************
{
 const int   MAXBUF = 10000;      // A puffermret byte-ban

 int         ihandle;             // Az input file azonost
 char        ipuffer[ MAXBUF ];   // Input puffer
 int         ohandle;             // Az output file azonost
 char        opuffer[ MAXBUF ];   // Output puffer
 char        ch;                  // A msols munkavltozja

 clrscr();

 if ( argc != 3 )
   { cerr << "Hasznlata " << endl;
     cerr << "  file msolshoz :  tc077-3 file1 file2"          << endl;
     cerr << "  nyomtatshoz    :  tc077-3 file1 prn/lpt1/lpt2"  << endl;
     cerr << "  line-editorknt :  tc077-3 con file"             << endl;
     cerr << "      ekkor file lezrs: ctrl-Z, Enter"           << endl;
     cerr << "  kpernyre rs :  tc077-3 file con"             << endl;
     exit(-1);
   }

 // Ltrehozzuk az ifstream input, s az ofstream output file-objektum
 // tpusokat. Az alkalmazott konstruktor fggvnnyel ezttal fggvny-
 // kezelst gyorst puffert is megadunk.

 // Megnyits az alacsonyszint _open fggvnnyel.
 // Ez a file-t mindenkppen binrisan nyitja meg.
 ihandle = _open( argv[1], O_RDONLY );
 if ( ihandle == -1 )
   { cerr << "Nem nyithat meg a(z) " << argv[1] <<
	     " forrs file olvassra" << endl;
     switch ( errno )
       { case ENOENT:  cout << "-> A file nem tallhat" << endl; break;
	 case EMFILE:  cout << "-> Tl sok nyitott file" << endl; break;
	 case EACCES:  cout << "-> Engedly megtagadva"  << endl; break;
	 case EINVACC: cout << "-> rvnytelen elrs"   << endl; break;
	 default: cout << "--> Hiba az '_open' fv.-nl!" << endl; break;
       }
     exit(-1);
   }
 // Puffer hozzrendelse a megnyitott file-hoz (a source ltrehozsa)
 ifstream     source( ihandle, ipuffer, sizeof(ipuffer) );

 // Megnyits az alacsonyszint _creat fggvnnyel.
 // Turbo C++ esetn az _open nem alkalmas j file megnyitsra,
 // ezrt van szksg a _creat fggvnyre.
 // A Microsoft C++ esetn hasznlhat az albbi fggvny is
 //     ohandle = _open( argv[2], _O_CREAT | _O_WRONLY );
 ohandle = _creat( argv[2], 0 );
 // A cl file-t ltrehozza, ha nem ltezik, egybknt pedig fellrja.
 if ( ohandle == -1 )
   { cerr << "Nem nyithat meg a(z) " << argv[2] << " clfile rsra\n";
     switch ( errno )
       { case ENOENT:  cout << "-> A file nem tallhat" << endl; break;
	 case EMFILE:  cout << "-> Tl sok nyitott file" << endl; break;
	 case EACCES:  cout << "-> Engedly megtagadva"  << endl; break;
	 default: cout << "--> Hiba a '_creat' fv.-nl!" << endl; break;
       }
     exit(-2);
   }
 // Puffer hozzrendelse a megnyitott file-hoz (a dest ltrehozsa)
 ofstream     dest( ohandle, opuffer, sizeof(opuffer) );

 // FILE MSOLS/NYOMTATS
 while ( source.get(ch) )  dest.put(ch);
 // A msols befejezshez a puffer tartalmt
 // ki kell rteni a file-ba:
 dest.flush();

 // Mindkt file bezrsa
 cout << "A file-msols sikeresen befejezdtt..." << endl;
 source.close();
 if ( strcmp(argv[2],"con")  &&
      strcmp(argv[2],"prn")  &&
      strcmp(argv[2],"lpt1") &&
      strcmp(argv[2],"lpt2")   )
    // Ha az output egy file,
    { cout << "Ez egy file msols volt!" << endl;
      // akkor azt le kell zrni.
      dest.close();
    }
 else
   { // Most kpernyre, vagy nyomtatra rt
     // (Ha norml mdon lpnk ki, akkor kilpskor mgegyszer kir.)
     exit(0);
   }

 cout << "Itt a vge!!!" << endl;

} //main
