// Program TC080.CPP                                        (Rajz1.cpp)
//---------------------------------------------------------------------
// Grafikai demo program
//  - httrszn vltoztatsa
//  - rajzols
//  - szvegkirs grafikus zemmdban
//---------------------------------------------------------------------
// A fejleszt krnyezet belltsai:
//   Option/Compiler/Entry/DOS-Standard: (.)
//   Option/Linker/Libraries/Graphics libraries: [x]
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.10.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <graphics.h>   // DETECT, initgraph, graphresult,
                        // grapherrormsg, grOk, closegraph, ...
#include <stdlib.h>     // exit
#include <dos.h>        // delay
#include <conio.h>      // clrscr
#include <string.h>     // strcpy
//--------------------------------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void grkezd();
    void grvege();
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void grkezd()
//----------------------------------------------------------------------
// Inicializlja a grafikus rendszert, a hardvert grafikus mdba lltja
//----------------------------------------------------------------------
{
  int         gdriver = DETECT;   // automatikus detektlsi igny
  int         gmode, errorcode;
  char        utvonal[20];
  

  // Grafikus inicializls (az initgraph hasznlata):
  // Az initgraph harmadik paramtere a grafikus meghajt elrsi utja
  //  a.) ha az aktulis knyvtrban van, akkor a harmadik paramter: ""
  //  b.) a paramter helyre rhatjuk az utat:
          // pl.:   "meghajt:\\tvonal\\BGI" mdon stringknt,
  //  c.) vagy az utat tartalmaz stringet:
          // pl.:   strcpy(utvonal, "C:\\TC3\\BGI");
  //   d.) bekrjk az elrsi utat:
          // pl.:   cout << "Krem az egavga.bgi file elrsi utjt: ";
          //        cin >> utvonal;
          
  strcpy(utvonal, "C:\\TC3\\BGI");
  initgraph(&gdriver, &gmode, utvonal);

  // az inicializls sikeressgnek vizsglata:
  errorcode = graphresult();
  if ( errorcode != grOk )      // grOk : nincs hiba
    { cout << "Grafikus hiba: "<< grapherrormsg( errorcode ) << endl;
      exit(1);                  // a hibakddal tr vissza
    }  
} //grkezd


void grvege()
//---------------------------------------------------------------------
// Lezrja a grafikus rendszert
//---------------------------------------------------------------------
{
  closegraph();
} //grvege


/**********/
void main()
/**********/
{
 char    szoveg1[] = " GRAFIKUS  DEMO PROGRAM ";
 char    szoveg2[] = " EZ EGY KR ";

 grkezd();                 // grafikus inicializls
 setbkcolor( LIGHTRED );   // httrszn bellts: vilgospiros = 12
 setcolor( BLUE );         // rajzolszn bellts: kk = 1
 circle( 100, 100, 50 );  // kr rajzols: kzppont koordinti,sugr
 settextstyle( DEFAULT_FONT, HORIZ_DIR, 3 );
                             // aktulis karakterkszlet, kirs irnya,
                             // karakterek mrete:
                             // alaprtelmezett, vzszintes,hromszoros
 setcolor( CYAN );          // rajzolszn bellts: cin = 3
 moveto( 200,100 ) ;        // a kurzort az x,y pontba mozgatja
 outtext( szoveg2 );        // az aktulis pozicitl szveget r
   
 delay( 5000 );             // vrakozik 5000 msec-et

 setbkcolor( 10 );          // httrszn  vilgoszld = 10
 setcolor( RED );
 settextjustify( CENTER_TEXT, BOTTOM_TEXT );
                            // szveg belltsi rtkekekt hasznlja
                            // az outtext s outextxy fggvnyeknl
 settextstyle( SCRIPT_FONT, HORIZ_DIR, 4 );
 outtextxy( 300, 300, szoveg1 );
 delay( 5000 );

 setbkcolor( 7 );           // httrszn  vilgosszrke = 7
 setcolor( YELLOW );        // rajzolszn srga = 14

 settextjustify( RIGHT_TEXT, BOTTOM_TEXT );
 settextstyle( BOLD_FONT, HORIZ_DIR, 2 );
 outtextxy( 400, 400, "2000.prilis.28." );

 delay( 5000 );

 grvege();
} //main
