/*  NEMLIN.H  */
#include <iostream.h>
#include <math.h>
typedef char ftnev[20];
typedef double dfunc(double x);
typedef dfunc  *dfptr;

double fg(double x);
double dfg(double x);

int Felezo(double a,double b,
           double eps,
           double *gyok,
           dfptr  f);

dfunc   fg;   /* Az f(x) = 0 nemlineris egyenlet  */

void menu(double a,double b,double eps);
void hangn();

void hangn()
{
        sound(1000);
        delay(30);
        sound(500);
        delay(30);
        nosound();
}

void intfel()
{
  fstream datafilen;
  double a,b,eps;
  double x0;
  double *gyok=&x0;
  ftnev  fnevn;
  int ok,fileerrn;
  char mentn;

 do{
  gotoxy(3,2);
  cputs("Kvnja majd az adatokat menteni? (I/N)\n");
    do{
        mentn=getch();
        hangn();
        mentn=toupper(mentn);
    }while((mentn!='I') && (mentn!='N'));
    if (mentn=='I')
    {
        gotoxy(3,3);
        cputs("Krem adja meg a file nevt az elrsi ttal egytt! ");
        gotoxy(3,4);
        cin>>fnevn;
        hangn();
        clrbufg();
        datafilen.open(fnevn,ios::out);
        if(datafilen.fail())
        {
          cputs("A file mvelet nem sikerlt!");
          fileerrn=1;
          getch();
          hangn();
        }

     }
}while(fileerrn==1);


  window(1,1,80,25);
  textbackground(1);
  clrscr();
  cout<<endl;
  cout<<"Nemlineris egyenlet megoldsa"<<endl;
  if (mentn=='I') datafilen<<"Nemlineris egyenlet megoldsa"<<endl;
  cout<<endl;
  cout<<"Intervallum eleje : "; cin>>a;
  if (mentn=='I') datafilen<<"Intervallum eleje : "<<a<<endl;
  cout<<"Intervallum vge  : "; cin>>b;
  if (mentn=='I') datafilen<<"Intervallum vge : "<<b<<endl;
  cout<<"Hibakorlt        : "; cin>>eps;
  if (mentn=='I') datafilen<<"Hibakorlt   :"<<eps<<endl;
  *gyok=0.0;
  ok=Felezo(a,b,eps,gyok,fg);
  if(ok){
          cout<<endl;
          cout<<"A nemlineris egyenlet gyke : "<<*gyok<<endl;
          if (mentn=='I') datafilen<<"A nemlineris egyenlet gyke : "<<*gyok<<endl;
         }
    else{
          cout<<"A mdszer nem alkalmazhat!"<<endl;
          if (mentn=='I') datafilen<<"A mdszer nem alkalmazhat"<<endl;
        }
  if (mentn=='I') datafilen.close();
  getch();
  hangn();
}

double fg(double x)
{
   return (x*x*x+x-0.7);
}

int Felezo(double a,     /* intervallum eleje     */
           double b,     /* intervallum vge      */
           double eps,   /* hibakorlt            */
           double *gyok, /* gyk -> eredmny      */
           dfptr f)      /* az f(x) fggvny cime */
{
    double fa,fb,x,fx;

    fa=(*f)(a);fb=(*f)(b);
    *gyok=0.0;

    if (fa*fb>0.0) return 0;
    fx=fabs(fa);
    while (fx>eps)
    {
      x=(a+b)/2;
      fx=(*f)(x);
      if(fx*fa>0.0) {a=x;fa=fx;} else b=x;
      fx=fabs(fx);
   }
   *gyok=x;
   return 1;
}

