/* Program TX019.c                                                      */
/*----------------------------------------------------------------------*/
/* Az N-ik Fibonacci szm meghatrozsa                                 */
/* Megjegyzs:                                                          */
/* 1. A program elzetes vizsglattal kizrja az illeglis rtkmegadst*/
/* 2. A program a szemllteti                                           */
/*    2.1. a tbbszrs rekurzv fggvnyhvst,                        */
/*    2.2. a kiszmtst itercival,                                   */
/*    2.3. az iterci s a rekurzi futsi-eredmny ekvivalencijt,   */
/*    2.4. az iterci s a rekurzi erforrs-igny klnbsgt.       */
/*----------------------------------------------------------------------*/
/* A matematikai modell:                                                */
/* F(0) = 0                                                             */
/* F(1) = 1                                                             */
/* F(N) = F(N-1) + F(N-2)                                               */
/*----------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.18.                                */
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <ctype.h>
#include <conio.h>

void nbekerese(int maximum,int& szam)
/*----------------------------------------------------------------------*/
/* A n egszszm bekrse vizsglattal                                  */
/*----------------------------------------------------------------------*/
{                 /*{ Az nbekerese utastsblokkja*/
  printf("Az n-ik Fibonacci szm generlsa, ahol 0 < n < %d.\n", maximum);
  do
  {
    printf("n : "); scanf("%d",&szam);
  }
  while (!(szam >= 0 && szam <= maximum));
}    /* nbekerese eljrs */

char modszer ()
/*----------------------------------------------------------------------*/
/* Programozstechnikai mdszer vlaszts                               */
/* (A matematikai modell ugyanaz)                                       */
/* 'I' : A szmtsi eljrs itercis                                  */
/* 'R' : A szmtsi eljrs rekurzv (ezttal tbbszrs)              */
/*----------------------------------------------------------------------*/
{
  char valasz ;
                         /* A modszer utastsblokkja */
  do
    {
    printf("A kiszmtsi eljrs (I)tercis, vagy (R)ekurzv : ");
    valasz = getch();
    printf("\n");
    valasz = toupper(valasz);
    }
  while (!(valasz == 'I' || valasz == 'R'));
  return valasz;
}     /* modszer */

long int ifibonacci(int n)
/*----------------------------------------------------------------------*/
/* n-ik fibonacci szm ellltsa itercival.                         */
/*----------------------------------------------------------------------*/
{
  long int munkan, munkan_1, munkan_2 ;
  int index  ;
                              /* Az ifibonacci utastsblokkja  */
  if (n == 0 )
    return  0 ;
   else
    if (n == 1 )
      return  1;
    else
      {
        munkan_2 = 0;  /* n = 0 */
        munkan_1 = 1;  /* n = 1 */
        for (index = 2; index<= n; index = index + 1 )
          {
            munkan   = munkan_1 + munkan_2;
            munkan_2 = munkan_1;
            munkan_1 = munkan;
          }
        return  munkan;
      }
}     /* ifibonacci */

long int rfibonacci(int n )
/*----------------------------------------------------------------------*/
/* n-ik fibonacci szm ellltsa tbbszrs rekurzv fggvnyhvssal.*/
/*----------------------------------------------------------------------*/
{                           /* A rfibonacci utastsblokkja*/
  if (n == 0)
    return  0 ;
   else
    if (n == 1 )
      return  1 ;
    else
      return rfibonacci(n-1) + rfibonacci(n-2);
}    /* rfibonacci */
void main()
{                          /* A fprogram utastsblokkja */
  const int MAX = 46;
                    /* Ennl nagyobb n esetn az eredmny kikerlne az */
                    /* engedlyezett tartomnybl.*/
  int n  ;
  long int fibonacci ; /* A long int 32 bites eljeles fixpontos tpus. */
                       /*       rtktartomnya: -2^31...+2^31-1.   */

  /* Adatbekrs rtkvizsglattal */
  nbekerese(MAX, n);

 /* mdszervlaszts */
  if (modszer() == 'I')
    /* Itercis mdszer */
    fibonacci = ifibonacci(n);
  else
    /* Rekurzis mdszer */
    fibonacci = rfibonacci(n);

  /* Az n-ik fibonacci szm ellltsa */
  printf("A(z) %d-ik fibonacci szm : %ld\n", n, fibonacci);
}

/*
A program futtatsa:
--------------------

Az n-ik fibonacci szm generlsa, ahol (0  n  46).
n : 46
A kiszmtsi eljrs (I)tercis, vagy (R)ekurzv : i
A(z) 46-ik fibonacci szm : 1836311903
*/
