// Program TC020-2.cpp                                 /* TC0REND.cpp */
//----------------------------------------------------------------------
// A hrom alaprendezs algoritmusa :
//     - Rendezs kzvetlen beszrssal
//     - Rendezs minimum kivlasztssal
//     - Buborkos rendezs
//----------------------------------------------------------------------
// Az utols javts dtuma: 2001.03.06.
//----------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>
#include <ctype.h>
#include <iomanip.h>
#include <stdlib.h>
#include <conio.h>		// clrscr(), getch()
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk                  
//......................................
const int        MAX = 20;            // A tmbmret definilsa
typedef int      tomb[MAX] ;          // A tmbtpus definilsa
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipusok)
//......................................................
//void main();
   void clrbuf();
   char valasz();
   void beolvas( tomb&, int& );
   void kiir( tomb, int );
   void kozvetlen( tomb&, int );
   void kivalaszt( tomb&, int ) ;
   void buborek( tomb&, int );
   void atir( tomb&, tomb, int );
//------------------------------------------------------

void clrbuf()
{ while (cin.get() != '\n'); }


char valasz()
{     char   kar;
      do {           // Csak igen s nem vlasz lehetsges
      cout << "       Van mg adat?    i/n ";
      cin >> kar;      clrbuf();
      kar = toupper(kar);  }
      while ( (kar != 'N') && (kar != 'I'));
      return kar;
}


void beolvas( tomb&     a,
              int&      db )
{   int   index, szam;
    index = 0 ;
    do  {
         cout << "Krem a szmot:   ";
         cin >> szam ;
         a[index] = szam;
         index++  ;
        }
    while (valasz() != 'N');
    db = index-1;
} // beolvas


void kiir( tomb    t,
           int     n )
{   int    j;

    for (j = 0 ; j <= n ; j++)
	 cout << setw(8) << t[j];
    cout<< endl;
//    getch();
} // kiir


//******************************
// Kzvetlen beszr rendezs
//******************************
//Elve : A sorozatot kettosztjuk. A msodik rsz els
//     elemt hasonltjuk ssze az els rsz utols elemvel.
//     Ha a felttelvizsglat szerint - nvekv rendezsnl -
//     a msodik rsz els eleme (x-ben is van), kisebb az els
//     rsz utols elemnl, az els rsz elemt az utols helyre rjuk.
//     A vizsglatot folytatjuk mg tallunk kisebbet, illetve a sorozat
//     vgre rtnk( balra).  Ekkor a bels ciklusbl kilpnk,
//     a vizsglt elemet  a helyre tesszk   (a[j+1]:=x;).
//.......................................................................

void kozvetlen( tomb& a, int n)
{    int      i, j, x ;
     cout << " EREDETI tmb" << endl  ;
     kiir(a,n);
     cout << " RENDEZS" << endl;
     for (i = 1; i <= n; i++)
      {     x    =  a[i];          // kezdrtkek belltsa
	    j    =  i-1;
	while  (x < a[j] && j >= 0)
	{  a[j+1] = a[j];
	   j      = j-1;
	}   ;
	a[j+1]  = x;
	kiir(a,n);
      }   // for vege
} // kozvetlen


//***********************************
// Rendezs Minimum kivlasztssal
//***********************************
//Elve: Minden egyes vizsglt sorozat ( ezek egyre rvidlnek) vgn
//    a sorozat legkisebb eleme a helyre kerl.
//    A kls ciklus ltal meghatrozott elemet (a[i] = x) sszehasonltjuk
//    a sorozat minden elemvel, nmagval nem. Ha tallunk olyan elemet,
//    amely kisebb x -nl, akkor ennek megrizzk az indext, s ezt az
//    elemet helyezzk x-be. A sorozat vgre rve, megkapjuk x-ben a  vizsgl
//    sorozat legkisebb elemt, s ennek indext ( k ).
//    Mivel a legkisebb elemet x-ben rizzk, ennek helye szabad,
//     ezrt elszr ide tesszk a kiindul a[i] elemet, majd a[i] helyre
//    az x-t, azaz a vizsglt sorozat legkisebb elemt.
//.......................................................................

void kivalaszt( tomb&    a,
		int      n )
{
   int     i, j, k, x;
   cout << " EREDETI tmb" << endl  ;
   kiir(a,n);
   cout << " RENDEZS" << endl;
   for (i = 0; i <  n; i++)
     {
       k = i;
       x = a[i];
       for (j = i+1; j <= n; j++)
	 if (a[j] < x) {  k = j ;
			  x = a[j];}
       a[k] = a[i];
       a[i] = x;
       kiir(a,n);
     } // for i
} // kivalaszt


//*******************************
// Buborkos rendezs
//*******************************
// Elve:  Pronknt hasolt ssze , s mindig cserl, ha a felttel
//     nem  megfelel. Egy bels ciklusnl egy elem
//     buborkol az els helyre, majd gy folytatdik.
//     Mdostott vltozatnl, amikor  esetleg kevesebb csert
//     vgez el a rendezs, akkor  azt figyeljk,
//     hogy volt-e csere az adott bels ciklusban vagy nem. Ha volt csere
//     akkor a csere karakter vltozt igen lltjuk, s folytatjuk
//     az sszehasonltst.
//     Ha nem volt csere, akkor biztosan minden elem a helyn van,
//     a rendezs teht vget rt.
//.......................................................................

void buborek( tomb&    a,
	      int      n )
{
   int    j, x ;
   char   csere  ;
   cout << " EREDETI tmb" << endl  ;
   kiir(a,n);
   cout << " RENDEZS" << endl;
//  for (i = 1; i < n ; i++)        // eredeti elv
//  for (j = n-1; j < = i; j--)     // eredeti elv}

   do  {
      csere = 'N';                   //  mdostott bubork rendezs
       for (j = n; j > 0; j=j-1)
          if (a[j]  <  a[j-1] )
          {    csere  = 'I';
               x      = a[j];
               a[j]   = a[j-1];
	       a[j-1] = x;
          }   //  if vege
          kiir(a,n);
     }
   while (csere == 'I');
} // buborek


void atir (tomb& vek, tomb s, int n)
{   int  index;
    for (index = 0; index <= n ; index++)
      vek[index] = s[index];
}

//*********
void main()
//*********
{
  tomb     vektor,eredeti ;
  int      n   ;
  char     valasztas  ;
   n  =  0;
   beolvas(eredeti,n);
   cout << "A MEN megjeletshez egy billenty lenyomsa szksges"<< endl;
//   atir(vektor,eredeti,n);
   do {
       getch();     // billenty letsre vr
       cout << "    K ----- Kzvetlen BESZR rendezs"<< endl;
       cout << "    M ----- Kzvetlen MINIMUM kivlasztsos rendezs"<< endl;
       cout << "    B ----- BUBORKOS rendezs"<< endl;
       cout << "    L ----- LISTZ "<< endl;
       cout << "    V ----- VGE "<< endl;
       cout << endl;
       cout << "                            Vlaszts:  ";
       cin >>  valasztas; clrbuf();
       valasztas = toupper(valasztas);
       clrscr();
       cout << "A tmb elemei "<< endl;
       switch  (valasztas)
	 { case 'K' :  atir(vektor, eredeti, n); kozvetlen(vektor,n) ; break;
	   case 'M' :  atir(vektor, eredeti, n); kivalaszt(vektor,n);  break;
           case 'B' :  atir(vektor, eredeti, n); buborek(vektor,n);    break;
           case 'L' :  kiir(eredeti,n);                                break;
           case 'V' :  exit(0);                                        break;
           default  :  cout << " Legyen vge? " ;
         }
       cout << endl;
      } while  (valasztas != 'V');
} //main
