// Program TC053.cpp
//---------------------------------------------------------------------
// Objektumhasznlat
// Osztly tpus objektum kls metdussal s kls konstruktorral
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.04.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <string.h>     // strcpy
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
class dolgozo
// Ez egy osztly-tpus kls metdussal, s kls konstruktorral
{
  private:
    // A privt tagok csak ebben az osztlyban lthatk
    // Alaprtelmezs - a "private" cmke elhagyhat
    typedef char     nev_tipus[20];     // Tpustag

  public:
    // A nyilvnos tagok lthatak csak kvlrl is
    nev_tipus        neve;              // Adattag
    long int         azonositoja;       // Adattag
    long int         fizetese;          // Adattag

    void adatkiirasa();                 // Metdustag prototpusa
                                        // (a definci kvl van)

    dolgozo(nev_tipus,                  // Konstruktor prototpusa
            long int, long int);        // (a definci kvl van)
}; //dolgozo
//--------------------------------------

void dolgozo::adatkiirasa()
// Ez egy kls metdus a "::" hivatkozssal az osztly nevre
{
  cout << "Nv       : " << neve        << "\n";
  cout << "Azonost : " << azonositoja << "\n";
  cout << "Fizets   : " << fizetese    << "\n";
  cout << "\n";
} //adatkiirasa

dolgozo::dolgozo(nev_tipus       nev,
		  long int       azonosito,
		  long int       fizetes)
// Ez egy kls konstruktor a "::" hivatkozssal az osztly nevre.
// A konstruktor fggvny neve megegyezik az objektum-tpus (mely
// ezttal egy osztly-tpus) nevvel.
// A konstruktor fggvnynek nincs tpusa (de a void szt sem kell
// lerni).
// A konstruktor fggvny minden objektumpldny ltrehozsakor
// automatikusan lefut.
// Ennek kvetkeztben az adattagok inicializlsra is hasznlhat,
// amint ezt ez a konstruktor fggvny teszi is.
{
  strcpy(neve, nev);
  azonositoja = azonosito;
  fizetese = fizetes;
} //dolgozo::dolgozo

/**********/
void main()
/**********/
{
  // Objektum ltrehozs ("deklarcival").
  // Ha egyes pldnyok ltrehozsakor alkalmazzuk a konstruktor
  // fggvnyt, akkor azoknak a konstruktorban kijellt adattagjai
  // egyttal inicializltak lesznek.
  // Ha az objektumban deklarltunk konstruktort,
  // akkor hasznlnunk is kell (ez esetenknt alibi rtkadst jelent).
  dolgozo       munkas("Kiss Jnos", 123456L, 20000L);
  dolgozo       fonok1("Nagy Pter", 12L, 200000L);
  dolgozo       fonok2("valami", 0L, 0L);       // alibi rtkek

  // rtkads a konstruktorral val inicializls sorn mr megtrtnt

  // Objektum rtkads
  fonok2 = fonok1;

  // Kiiratas az objektumok metdusval
  munkas.adatkiirasa();
  fonok1.adatkiirasa();
  fonok2.adatkiirasa();
} //main
