// Program TC070-1.cpp
//---------------------------------------------------------------------
// Szveges file-kezels
//   - szveges file ltrehozsa
//   - numerikus adat szveges file-ba rsa (egy adat - egy sor mdon)
//   - numerikus adat szveges file-bl val beolvassa (karakterenknt)
//     ---> while ciklussal, elreolvasssal (olvassi kisrlettel) !!!
//   - hozzrs a szveges file tartalmhoz
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.25.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setw
#include <ctype.h>      // toupper
#include <string.h>     // strcmp
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXNAME = 20;         // A max. file-nv hossz
const int       NUMLGT = 6;           // A bevitt szmok max. hossza
const int       MAXNUM = 5;           // A max. adatszm a file-ban

typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
typedef enum    { iras, olvasas, hozzairas
                }  modtipus;          // file-megnyitsi md
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    void clrbuf();
    int megnyit( fstream&, ftnev, modtipus );
    void lezar( fstream& );
    void kiir( fstream& );
    void hozzair( fstream& );
    void beolvas( fstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()  { while ( cin.get() != '\n' ); }
//*******************************************
// Billentyzetpuffert trl fggvny
//*******************************************


int megnyit( fstream&     adatf,
             ftnev        fnev,
             modtipus     nyitas )
//***********************************************************************
// 1. A msodik paramterknt megadott nev fizikai file-hoz hozzrendeli
//      az fstream adatfolyamot,
// 2. majd ezt megnyitja a harmadik paramterben megadott mdon
//      rsra, olvassra, vagy hozzrsra
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Ha a megnyits sikeres, akkor a visszatrsi rtk 0,
//      egybknt a megnyitsi mdtl fggen 1, 2, vagy 3.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits 
  switch ( nyitas )
    { case  iras       : adatf.open( fnev, ios::out ); break;
      case  olvasas    : adatf.open( fnev, ios::in );  break;
      case  hozzairas  : adatf.open( fnev, ios::app ); break;
    }

  // A megnyits sikeressgnek vizsglata
  if ( ! adatf.fail() )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    switch ( nyitas )
      { case  iras :
          cout << "A kimeneti file megnyitsa nem sikerlt." << endl ;
          return 1;
        case  olvasas :
          cout << "A bemeneti file megnyitsa nem sikerlt." << endl ;
          return 2;
        case  hozzairas :
          cout << "A kimeneti file megnyitsa nem sikerlt." << endl ;
          return 3;
        default :
          // Hibs megnyitsi md hasznlat
          return 999;
      }
} //megnyit


void lezar( fstream&    adatf )
//***********************************************************************
// A paramterknt megadott adatfolyamot lezrja.
//***********************************************************************
{
  // A file lezrsa
  adatf.close();
} //lezar


void kiir( fstream&    adatfile )
//***********************************************************************
// A paramterknt megadott szveges file-ba
// addig r egsz szmokat a felhasznl,
// amg egy "N" betvel nem jelzi az adatbevitel befejezsnek szndkt,
// vagy az adatbevitelek szma nem ri az engedlyezett korltot.
// (Ha az "N" helyett tetszleges karaktert, vagy csak egy "Enter"-t t
// le a felhasznl, akkor az adatbevitel folytatdik.
// Minden elemi adat berst egy sorvgjel zrja le.
// A felhasznlt globlis azonost:
//              MAXNUM : a file-ba rhat adatok maximlis szma
//***********************************************************************
{
  const int   QQ = 2;           // a folytatja string min. hossza, mivel
  char        folytatja[QQ];    // a stringlezr kar.-t is trolnia kell
  int         adat;
  int         index;

  // Az adatok bersa a szveg tpus "adatfile" file-ba
  // egy adat - egy sor bevitellel
  index = 1;
  do { cout << "Az " << index << "-ik adat : ";
       cin >> adat;  clrbuf();      // beolvass + puffertrls
       adatfile << adat << endl;    // file-ba rs sorlezrssal
       if ( index == MAXNUM )
         // Kiugrs az adatbevitelbl
         return;
       index++;
       cout << "           folytatja? (I/N) " ;
       cin.getline( folytatja, QQ );
       folytatja[0] = toupper( folytatja[0] );
     } while ( strcmp( folytatja, "N" ) != 0 );
} //kiir


void hozzair( fstream&    adatfile )
//***********************************************************************
// A paramterknt megadott file tartalmhoz hozzrja a felhasznl
// ltal megadott egsz szmokat mindaddig, amg 9999-et nem r be.
//***********************************************************************
{
  int      adat;

  // Az adatok hozzrsa a szveg tpus "adatfile" file tartalmhoz
  cout << "Irjon be j adatot (befejezshez: 9999)!" << endl;

  // Az adatok bersa a szveg tpus "adatfile" file-ba
  // egy adat - egy sor bevitellel
  cin >> adat;
  while ( adat != 9999 )
    { adatfile << adat << endl;    // file-ba rs sorlezrssal
      cin >> adat;
    }
} //hozzair


void beolvas( fstream&    adatfile )
//***********************************************************************
// A paramterknt megadott file-bl beolvassa az egsz szmokat,
// majd minden beolvasott szmrtket kir a kpernyre.
// Mdszer: 1. Elreolvass, 2. Ciklikus ellenrzs-feldolgozs-beolvass
//***********************************************************************
{ char     egykar;

  // Elreolvass a file-bl (olvassi kisrlet) !!!
  adatfile.get(egykar);
  // File-vg ellenrzst kvet ciklikus feldolgozs-beolvass
  while ( ! adatfile.eof() )
     { // Kirats a kpernyre
       cout << egykar;
       // Beolvass a file-bl
       adatfile.get(egykar);
     }
  cout << endl;
} //beolvas


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      fnev;                // fizikai filenv
  fstream    datafile;            // logikai file-objektum ltrehozsa
  int        hibakod;             // file-megnyitsi hibakd
  modtipus   megnyitasi_mod;      // file-megnyitsi md

  // A kimeneti fizikai file nevnek bekrse
  cout << "Adja meg a file nevt az elrsi ttal egytt! ";
  cin  >> fnev;

  // KIIRS =============================================================
     // Fizikai file-nv hozzrendels, megnyits rsra, ellenrzs
     megnyitasi_mod = iras;
     hibakod = megnyit( datafile, fnev, megnyitasi_mod );
     if ( hibakod != 0 )
       // Kiugrs az opercis rendszerbe hibakddal
       exit( hibakod );

     // Adatbekrs s file-ba rs
     kiir( datafile );

     // A file lezrsa
     lezar( datafile );

  // BEOLVASS ==========================================================
     // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
     megnyitasi_mod = olvasas;
     hibakod = megnyit( datafile, fnev, megnyitasi_mod );
     if ( hibakod != 0 )
       // Kiugrs az opercis rendszerbe hibakddal
       exit( hibakod );

     // A file tartalmnak listzsa a kpernyre
     cout << "LISTZS:" << endl;
     beolvas( datafile );

     // A file lezrsa
     lezar( datafile );

  // HOZZIRS ==========================================================
     // Fizikai file-nv hozzrendels, megnyits hozzrsra, ellenrzs
     megnyitasi_mod = hozzairas;
     hibakod = megnyit( datafile, fnev, megnyitasi_mod );
     if ( hibakod != 0 )
       // Kiugrs az opercis rendszerbe hibakddal
       exit( hibakod );

     // Adatbekrs s file-ba rs
     hozzair( datafile );

     // A file lezrsa
     lezar( datafile );

  // BEOLVASS ==========================================================
     // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
     megnyitasi_mod = olvasas;
     hibakod = megnyit( datafile, fnev, megnyitasi_mod );
     if ( hibakod != 0 )
       // Kiugrs az opercis rendszerbe hibakddal
       exit( hibakod );

     // A file tartalmnak listzsa a kpernyre
     cout << "LISTZS:" << endl;
     beolvas( datafile);

     // A file lezrsa
     lezar( datafile );
//***********************************************************************
} //main
