// Program TC073.cpp
//---------------------------------------------------------------------
// Binris file-kezels I.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.04.30.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream, open, close, eof, tellg, tellp,
                        // write, read, seekp, seekg
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setw
#include <ctype.h>      // toupper
//--------------------------------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void clrbuf();
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()  { while (cin.get() != '\n'); }

/**********/
void main()
/**********/
{
 char         fnev[20];
 int          adat;
 fstream      adatfile;
 long int     inp_mutato, out_mutato;
 long int     offset, pozicio;
 char         valasz;

 // Az fnev fizikai file-nv hozzrendelse az adatfile logikai
 // file-nvhez (file-objektumhoz), majd ez utbbi megnyitsa
 // binris file-knt rsra
 cout << "Az adatfile neve: ";  cin >> fnev;
 adatfile.open( fnev, ios::binary | ios::out );

 // A tellg() az istream, a tellp() az ostream osztly tagja.
 // A C++ I/O rendszere minden megnyitott file-hoz kt file-mutatt
 // tart fenn. A tellg() a kvetkez inputmvelet helyt mutatja,
 // a tellp() a kvetkez outputmvelet pozcijra mutat.
 // A tellg() s a tellp() fggvnyek tpusa long int.
 //
 // Az adatfile feltltse adattal mindaddig mg 9999-et nem r
 // a felhasznl
 do { // Az input s az output file-pointerek lekrdezse
      inp_mutato = adatfile.tellg();
      out_mutato = adatfile.tellp();
      // A mutatk kiratsa
      cout << setw(8) << "input mutat: " << inp_mutato;
      cout << ",  output mutat: " << out_mutato << endl;
      // Adatbekrs
      cout << "Adat (vge:9999) : ";  cin >> adat;     clrbuf();
      // Az adat bersa az adatfile-ba addig,
      // amg a megadott adat rtke 9999 nem lesz
      if ( adat != 9999 )
        // A write tagfggvny az els paramterben hivatkozott cm
        // file-pufferbe rja a karaktersorozat formtumv konvertlt
        // adat-ot a msodik paramterknt megadott szm byte hosszban.
        adatfile.write( (char*)&adat, sizeof(adat) );
    } while ( adat != 9999 );
 // Az adatfile-ba rst befejeztk, ezrt lezrjuk a file-t
 adatfile.close();

 // SZEKVENCILIS FILE-KEZELS:
 // Az adatfile tartalmnak szekvencilis kiolvassa:
 cout << "A(z) " << fnev << " file tartalma: " << endl;
 //    1. A lezrt file-t megnyitjuk binris file-knt olvassra
 adatfile.open( fnev, ios::binary | ios::in );
 //    2. Elreolvass
 adatfile.read( (char*)&adat, sizeof(adat) );
 //    3. Ellenrzs
 while ( ! adatfile.eof() )
  { // 4. Feldolgozs (itt most kirs)
    cout << adat << " ";
    // 5. Ujraolvass
    adatfile.read( (char*)&adat, sizeof(adat) );
  }
 cout << endl;
 //    6. A file-t lezrjuk
 adatfile.close();

 // DIREKT FILE-KEZELS:
 // Az adatfile egy kijellt adatnak kzvetlen (nem szekvencilis)
 // kiolvassa:
 // A seekg() az istream, a seekp() az ostream osztly tagja.
 // A C++ I/O rendszerben a kzvetlen adatelrst e tagfggvnyekkel
 // valsthatjuk meg. Minden be- s kiviteli mvelet a megfelel
 // (input, illetve output) file-mutatt automatikusan elbbre lltja.
 // m, ha e szekvencilis elrstl eltren, kzvetlenl akarunk egy
 // file-beli adatra pozcionlni, akkor az input-pointert a seekg()
 // fggvnnyel, az output pointert pedig a seekp() fggvnnyel tudjuk
 // a kvnt rtkre lltani.
 // A seekg() s a seekp() fggvnyek els paramtere byte-ban adja meg
 // az eltolst a msodik paramterben megadott pozcitl, ahol beg: a
 // file eleje, cur: a file aktulis pozcija s end: a file vge.
 // VIGYZAT! Az eltols megadott rtkt a C++ NEM ellenrzi!
 //
 // A file kvnt sorszm adatnak kirsa:
 // 1. Megnyitjuk binris file-knt olvassra
 adatfile.open( fnev, ios::binary | ios::in );
 // 2. Belltjuk a kvnt elemsorszmot
 cout << "A krt adat sorszma: "; cin >> pozicio; clrbuf();
 // 3. Meghatrozzuk a hozztartoz file-beli pozcit
 offset = (pozicio - 1) * sizeof(adat);
 // 4. Pozcionlunk az input-pointer bellt fggvnnyel
 adatfile.seekg( offset, ios::beg );
       // Ellenrizzk a bellts helyessgt (elhagyhat)
       inp_mutato = adatfile.tellg();
       cout << "Az input mutat: " << inp_mutato << endl;
 // 5. Kiolvassuk a file-bl a kivlasztott adatot
 adatfile.read( (char*)&adat, sizeof(adat) );
 // 6. A kiolvasott adatot feldolgozzuk (ezttal kirjuk a kpernyre)
 cout << "A file " << pozicio << "-ik adata: " << adat << endl;
 // 7. Lezrjuk a megnyitott file-t
 adatfile.close();

 // FILE-TARTALOM MODOSITS DIREKT FILE-KEZELSSEL:
 // Az adatfile egy kijellt adatnak kzvetlen mdostsa:
 //
 // A file kvnt sorszm adatnak mdostsa:
 // 1. Megnyitjuk binris file-knt rsra s olvassra
 adatfile.open( fnev, ios::binary | ios::in | ios::out );
 // 2. Belltjuk a mdostani kvnt elemsorszmot
 cout << "A mdostand adat sorszma: "; cin >> pozicio; clrbuf();
 // 3. Meghatrozzuk a hozztartoz file-beli pozcit
 offset = (pozicio - 1) * sizeof(adat);
 // 4. Pozcionlunk az input-pointer bellt fggvnnyel
 adatfile.seekg( offset, ios::beg );
 // 5. Kiolvassuk a file-bl a kivlasztott adatot
 adatfile.read( (char*)&adat, sizeof(adat) );
 // 6. A kiolvasott adatot kirjuk a kpernyre
 cout << "A file " << pozicio << "-ik adata jelenleg: " << adat << endl;
 // 7. Ellenrz krds
 do { cout << "Valban meg kvnja vltoztatni? (I/N) : ";
      cin >> valasz; clrbuf(); valasz = toupper(valasz);
    } while ( valasz != 'I' && valasz != 'N' );
 if ( valasz == 'I' )
   { // 7-I.1. Belltjuk az output file pointert
     adatfile.seekp( offset, ios::beg );
            // Ellenrizzk a bellts helyessgt (elhagyhat)
            out_mutato = adatfile.tellp();
            cout << "Az output mutat: " << out_mutato << endl;
     // 7-I.2. Adatbekrs
     cout << "Az j adat: ";  cin >> adat;     clrbuf();
     // 7-I.3. Az adat bersa az adatfile-ba
     adatfile.write( (char*)&adat, sizeof(adat) );
   }
 // 8. Lezrjuk a megnyitott file-t
 adatfile.close();
 // 9. Az adatfile tartalmnak megjelentse:
 cout << "A(z) " << fnev << " file tartalma: " << endl;
 adatfile.open( fnev, ios::binary | ios::in );
 adatfile.read( (char*)&adat, sizeof(adat) );
 while ( ! adatfile.eof() )
  { cout << adat << " ";
    adatfile.read( (char*)&adat, sizeof(adat) );
  }
 cout << endl;
 adatfile.close();

 } //main
