// Program TC075-1.cpp
//---------------------------------------------------------------------
// Binris file feldolgozsa I. (Az input s az output file klnbz)
//---------------------------------------------------------------------
// Az int tpus input file adatainak ngyzeteit az output file-ba m-
// solja. Ha a ngyzetszm nagyobb, mint a legnagyobb brzolhat int 
// tpus rtk (a MAXINT), akkor a file-ba a MAXINT rtk kerl.
// A TC073 program segtsgvel elllthat a szksges binris file!
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.03.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream
#include <iostream.h>   // cin, cout
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXINT  = 32767;      // = 2^15-1
const int       MAXNAME = 20;         // A max. file-nv hossz
typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
typedef enum    { iras, olvasas
                }  modtipus;          // file-megnyitsi md tpusa
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    int megnyit( fstream&, ftnev, modtipus );
    void lezar( fstream& );
    void kiir( fstream& );
    void feldolgoz_masol( fstream&, fstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

int megnyit( fstream&     adatf,
             ftnev        fnev,
             modtipus     nyitas )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja a "nyitas" szerint rsra vagy olvassra,
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 1, vagy 2.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits
  switch ( nyitas )
    { case  iras    : adatf.open( fnev, ios::binary | ios::out ); break;
      case  olvasas : adatf.open( fnev, ios::binary | ios::in );  break;
    };
  // A megnyits sikeressgnek vizsglata
  if ( ! adatf.fail() )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    switch ( nyitas )
      { case  iras :
          cout << "A kimeneti file megnyitsa nem sikerlt." << endl ;
          return 1;
        case  olvasas :
          cout << "A bemeneti file megnyitsa nem sikerlt." << endl ;
          return 2;
        default :
          // Hibs megnyitsi md hasznlat
          return 999;
      };
} //megnyit


void lezar( fstream&    adatf )
//***********************************************************************
// A paramterknt megadott file-t lezrja.
//***********************************************************************
{
  adatf.close();
} //lezar


void kiir( fstream&     adatf )
//***********************************************************************
// A paramterknt megadott binris file tartalmt kiirja a kpernyre.
//***********************************************************************
{
 int     adat;

 // Az adatf binris file tartalmnak szekvencilis kiolvassa,
 // s kirsa a kpernyre
 adatf.read( (char*)&adat, sizeof(adat) );
 while ( ! adatf.eof() )
  { cout << adat << " ";
    adatf.read( (char*)&adat, sizeof(adat) );
  }
 cout << endl;
} //kiir


void feldolgoz_masol( fstream&    bemenet,
                      fstream&    kimenet )
//***********************************************************************
// Az els paramterknt megadott file-bl beolvassa az adatokat,
// majd a msodik paramterknt megadott file-ba kirja a ngyzetket.
//***********************************************************************
{
  int     adat;
  double  adat_teszt;

  // Elreolvass a bemeneti file-bl (olvassi kisrlet) !!!
  bemenet.read( (char*)&adat, sizeof(adat) );
  // File-vg ellenrzst kvet ciklikus kirs-beolvass
  while ( ! bemenet.eof() )
     { // A bemeneti adat feldolgozsa
       adat_teszt = (double)adat * adat;
       if ( adat_teszt > MAXINT )
         adat = MAXINT;
       else
         adat = (int)adat_teszt;
       // Az adat kiratsa a kimeneti file-ba
       kimenet.write( (char*)&adat, sizeof(adat) );
       // Uj adat beolvassa a bemeneti file-bl
       bemenet.read( (char*)&adat, sizeof(adat) );
     }
} //feldolgoz_masol


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      be_fnev;             // a bemeneti fizikai file neve
  ftnev      ki_fnev;             // a kimeneti fizikai file neve
  fstream    be_file;             // bemeneti logikai file ltrehozsa
  fstream    ki_file;             // kimeneti logikai file ltrehozsa
  int        hibakod;             // file-megnyitsi hibakd
  modtipus   megnyitasi_mod;      // file-megnyitsi md

  // A BEMENET ELKSZITSE ============================================
  // A bemeneti fizikai file nevnek bekrse
  cout << "A bemeneti file neve (az elrsi ttal egytt): ";
  cin  >> be_fnev;
  // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
  megnyitasi_mod = olvasas;
  hibakod = megnyit( be_file, be_fnev, megnyitasi_mod );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A KIMENET ELKSZITSE ============================================
  // A kimeneti fizikai file nevnek bekrse
  cout << "A kimeneti file neve (az elrsi ttal egytt): ";
  cin  >> ki_fnev;
  // Fizikai file-nv hozzrendels, megnyits rsra, ellenrzs
  megnyitasi_mod = iras;
  hibakod = megnyit( ki_file, ki_fnev, megnyitasi_mod );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // A FELDOLGOZS-MSOLS =============================================
  cout << "Most folyik az adatfeldolgozs..." << endl;
  feldolgoz_masol( be_file, ki_file );
  // Az input s output file-ok lezrsa
  lezar( be_file );
  lezar( ki_file );

  // A BEMENETI ADATFILE KIIRATSA A KPERNYRE ========================
  cout << "A(z) " << be_fnev << " input file tartalma: " << endl;
  megnyitasi_mod = olvasas;
  megnyit( be_file, be_fnev, megnyitasi_mod );
  kiir( be_file );
  lezar( be_file );

  // A BEMENETI ADATFILE KIIRATSA A KPERNYRE ========================
  cout << "A(z) " << ki_fnev << " output file tartalma: " << endl;
  megnyitasi_mod = olvasas;
  megnyit( ki_file, ki_fnev, megnyitasi_mod );
  kiir( ki_file );
  lezar( ki_file );

} //main

/*
A program futtatsa:
--------------------

A bemeneti file neve (az elrsi ttal egytt): tc075a.dat
A kimeneti file neve (az elrsi ttal egytt): tc075b.dat
Most folyik az adatfeldolgozs...
A(z) tc075a.dat input file tartalma: 
11 0 -11 100 0 -100 200 0 -200 
A(z) tc075b.dat output file tartalma: 
121 0 121 10000 0 10000 32767 0 32767 
*/
