// Program TC075-2.cpp
//---------------------------------------------------------------------
// Binris file feldolgozsa II. (Az input s az output file azonos)
//---------------------------------------------------------------------
// Az int ttus adatfile adatait kicserli a ngyzetkkel.
// Ha a ngyzetszm nagyobb, mint a legnagyobb brzolhat int tpus
// rtk (a MAXINT), akkor a file-ba a MAXINT rtk kerl.
// A TC073 program segtsgvel elllthat a szksges binris file!
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.03.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream
#include <iostream.h>   // cin, cout
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXINT  = 32767;      // = 2^15-1
const int       MAXNAME = 20;         // A max. file-nv hossz
typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    int INPmegnyit( fstream&, ftnev );
    void IOmegnyit( fstream&, ftnev );
    void lezar( fstream& );
    void kiir( fstream& );
    void feldolgoz_atir( fstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

int INPmegnyit( fstream&     adatf,
		ftnev        fnev )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja binris mdon olvassra,
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 1.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits olvassra
  adatf.open( fnev, ios::binary | ios::in );

  // A megnyits sikeressgnek vizsglata
  if ( ! adatf.fail() )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    { cout << "Az adatfile megnyitsa nem sikerlt." << endl ;
      return 1;
    };
} //INPmegnyit


void IOmegnyit( fstream&     adatf,
		ftnev        fnev )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja binris mdon rsra s olvassra.
//***********************************************************************
{
  adatf.open( fnev, ios::binary | ios::in | ios::out );
} //IOmegnyit


void lezar( fstream&    adatf )
//***********************************************************************
// A paramterknt megadott file-t lezrja.
//***********************************************************************
{
  adatf.close();
} //lezar


void kiir( fstream&     adatf )
//***********************************************************************
// A paramterknt megadott binris file tartalmt kiirja a kpernyre.
//***********************************************************************
{
 int     adat;

 // Az adatf binris file tartalmnak szekvencilis kiolvassa,
 // s kirsa a kpernyre
 adatf.read( (char*)&adat, sizeof(adat) );
 while ( ! adatf.eof() )
  { cout << adat << " ";
    adatf.read( (char*)&adat, sizeof(adat) );
  }
 cout << endl;
} //kiir


void feldolgoz_atir( fstream&    adatf )
//***********************************************************************
// Az adatfile-bl beolvasott adatokat ngyzetre emeli, majd ezzel az
// rtkkel helyettesti az eredeti adatot.
//***********************************************************************
{
  int         adat;
  double      adat_teszt;
  long int    inp_mutato;
  long int    out_mutato;

  // Elreolvass a bemeneti file-bl (olvassi kisrlet) !!!
  adatf.read( (char*)&adat, sizeof(adat) );

  // File-vg ellenrzst kvet ciklikus kirs-beolvass
  while ( ! adatf.eof() )
     { // A bemeneti adat feldolgozsa (megvltoztatsa)
       adat_teszt = (double)adat * adat;
       if ( adat_teszt > MAXINT )
	 // A hatrrtk belltsa
	 adat = MAXINT;
       else
	 // Az adat visszakonvertlsa double tpusbl int tpusba
	 adat = (int)adat_teszt;

       // A kirsi file-pointer belltsa
       inp_mutato = adatf.tellg();
       out_mutato = inp_mutato - sizeof(adat);
       adatf.seekp( out_mutato, ios::beg );

       // A megvltoztatott adat kiratsa az adatfile-ba
       adatf.write( (char*)&adat, sizeof(adat) );

       // Uj adat beolvassa az adatfile-bl
       // (Ez egyben tovbblpteti a beolvassi file-pointert is)
       adatf.read( (char*)&adat, sizeof(adat) );
     }
} //feldolgoz_atir


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      fnev;               // az adatfile fizikai neve
  fstream    adatfile;           // a logikai file ltrehozsa
  int        hibakod;            // file-megnyitsi hibakd

  // ADATBEKRS, ADATFILE ELKSZITSE ================================
  // Az adatfile fizikai nevnek bekrse
  cout << "Az adatfile neve (az elrsi ttal egytt): ";  cin  >> fnev;
  // Fizikai file-nv hozzrendels, megnyits olvassra, ellenrzs
  hibakod = INPmegnyit( adatfile, fnev );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );

  // AZ EREDETI ADATFILE KIIRATSA A KPERNYRE ========================
  cout << "A(z) " << fnev << " file eredeti tartalma: " << endl;
  kiir( adatfile );
  // Az adatfile lezrsa
  lezar( adatfile );

  // A FELDOLGOZS-TIRS ==============================================
  // Az adatfile megnyitsa olvassra, rsra
  IOmegnyit( adatfile, fnev );
  cout << "Most folyik az adatfeldolgozs..." << endl;
  feldolgoz_atir( adatfile );
  // Az adatfile lezrsa
  lezar( adatfile );

  // AZ TIRT ADATFILE KIIRATSA A KPERNYRE ==========================
  // Az adatfile megnyitsa
  IOmegnyit( adatfile, fnev );
  cout << "A(z) " << fnev << " file mdostott tartalma: " << endl;
  kiir( adatfile );
  // Az adatfile lezrsa
  lezar( adatfile );

} //main

/*
A program futtatsa:
--------------------

Az adatfile neve (az elrsi ttal egytt): tc075.dat
A(z) tc075.dat file eredeti tartalma:
11 0 -11 100 0 -100 200 0 -200
Most folyik az adatfeldolgozs...
A(z) tc075.dat file mdostott tartalma:
121 0 121 10000 0 10000 32767 0 32767
*/
