// Program TC076.cpp
//---------------------------------------------------------------------
// Long int tpus binris file feltltse az els N Fibonacci szmmal,
// e szmok kpernyre val kiratsa a generls sorrendjben, majd a
// ltrehozott file kiolvassa a vgtl az elejig. A file nevt, s
// az N szm rtkt a felhasznl adja meg.
//---------------------------------------------------------------------
// A Fibonacci szmok ellltsnak matematikai modellje:
// F(0) = 0                                                             
// F(1) = 1                                                             
// F(N) = F(N-1) + F(N-2)                                               
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.03.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream
#include <iostream.h>   // cin, cout
#include <stdlib.h>     // exit
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int       MAXNAME = 20;         // A max. file-nv hossz
typedef char    ftnev[ MAXNAME ];     // A file-nv tpusa
//--------------------------------------

//------------------------------------------------------
// A prototipus-modell
//......................................................
//void main();
    int OUTmegnyit( fstream&, ftnev );
    void INPmegnyit( fstream&, ftnev );
    void feltolt( fstream&, int );
      long int fibonacci( int );
    void lezar( fstream& );
    void beolvas_visszafele( fstream& );
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

int OUTmegnyit( fstream&     adatf,
                ftnev        fnev )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja binris mdon rsra,
// 3. vgl pedig ellenrzi a megnyits sikeressgt.
//      Siker esetn a visszatrsi rtk 0, egybknt 1.
//***********************************************************************
{
  // Fizikai file-nv hozzrendels s file megnyits rsra
  adatf.open( fnev, ios::binary | ios::out );

  // A megnyits sikeressgnek vizsglata
  if ( ! adatf.fail() )
    // Ekkor a file-megnyits sikeres
    return 0;
  else
    // Ekkor a file-megnyits nem sikeres
    { cout << "A kimeneti adatfile megnyitsa nem sikerlt." << endl ;
      return 1;
    };
} //OUTmegnyit


void INPmegnyit( fstream&     adatf,
                 ftnev        fnev )
//***********************************************************************
// 1. Az "fnev" nev fizikai file-hoz hozzrendeli az "adatf" file-t,
// 2. majd ezt megnyitja binris mdon olvassra.
//***********************************************************************
{
  adatf.open( fnev, ios::binary | ios::in );
} //INPmegnyit


void lezar( fstream&    adatf )
//***********************************************************************
// A paramterknt megadott file-t lezrja.
//***********************************************************************
{
  adatf.close();
} //lezar


void beolvas_visszafele( fstream&     adatfile )
//***********************************************************************
// A paramterknt megadott binris file tartalmt visszafel beolvassa,
// majd a beolvasott rtkeket kiirja a kpernyre.
//***********************************************************************
{
 long int     adat;
 long int     offset;
 long int     inp_mutato;

 offset = sizeof(adat);
 adatfile.seekg( -offset, ios::end );

 // Ellenrizzk a bellts helyessgt
 inp_mutato = adatfile.tellg();
 // A beolvassi file-pointer kiratsa (csak a tesztelshez!)
 // cout << "Az input mutat: " << inp_mutato << endl;

 // Az adatf binris file tartalmnak fordtott irny beolvassa,
 // s kirsa a kpernyre
 while ( inp_mutato >= 0 )
  { adatfile.read( (char*)&adat, sizeof(adat) );
    cout << adat << ' ';
    adatfile.seekg( -2*offset, ios::cur );
    inp_mutato = adatfile.tellg();
    // A beolvassi file-pointer kiratsa (csak a tesztelshez!)
    // cout << "Az input mutat: " << inp_mutato << endl;
  }
 cout << endl;
} //beolvas_visszafele


void feltolt( fstream&    kimenet,
              int         N )
//***********************************************************************
// A paramterknt megadott file-t feltlti az els N Fibonacci szmmal.
//***********************************************************************
{
  long int     adat;
  int          index;

  for ( index = 0; index < N; index++ )
    {
     adat = fibonacci(index);
     // Az adat kiratsa a kpernyre
     cout << "A(z) " << index << "-ik Fibonacci szm: " << adat << endl;
     // Az adat kiratsa a kimeneti file-ba
     kimenet.write( (char*)&adat, sizeof(adat) );
    }
  cout << endl;  
} //feltolt


long int fibonacci( int     N )
//----------------------------------------------------------------------
// Az N-ik Fibonacci szm ellltsa itercival
//----------------------------------------------------------------------
{
  long int     munkaN, munkaN_1, munkaN_2;
  int          index;

  if ( N == 0 )
    return  0;
  else
    if ( N == 1 )
      return  1;
    else
      { munkaN_2 = 0;    // N = 0
        munkaN_1 = 1;    // N = 1
        for (index = 2; index <= N; index++)
          { munkaN   = munkaN_1 + munkaN_2;
            munkaN_2 = munkaN_1;
            munkaN_1 = munkaN;
          }
        return  munkaN;
      }
} //fibonacci


//***********************************************************************
void main()
//***********************************************************************
{
  ftnev      fnev;         // a fizikai file neve
  fstream    adatfile;     // a logikai file-objektum ltrehozsa
  int        hibakod;      // file-megnyitsi hibakd
  int        N;            // a hatrszm

  // ADATBEKRS, ADATFILE ELKSZITSE ================================
  // Az adatfile fizikai nevnek bekrse
  cout << "Az adatfile neve (az elrsi ttal egytt): ";  cin  >> fnev;
  // Fizikai file-nv hozzrendels, megnyits rsra, ellenrzs
  hibakod = OUTmegnyit( adatfile, fnev );
  if ( hibakod != 0 )
    // Kiugrs az opercis rendszerbe hibakddal
    exit( hibakod );
  // Az N hatrszm bekrse
  cout << "A hatrszm: ";  cin  >> N;

  // A FIBONACCI SZMOK GENERLSA, AZ ADATFILE FELTLTSE =============
  feltolt( adatfile, N );
  // Az adatfile lezrsa
  lezar( adatfile );

  // AZ ADATFILE KIIRATSA A KPERNYRE ================================
  // Az adatfile megnyitsa olvassra
  INPmegnyit( adatfile, fnev );
  cout << "A(z) " << fnev ;
  cout << " file tartalma visszafel olvasva: " << endl;
  beolvas_visszafele( adatfile );
  // Az adatfile lezrsa
  lezar( adatfile );

} //main

/*
A program futtatsa:
--------------------

Az adatfile neve (az elrsi ttal egytt): tc076.dat
A hatrszm: 7
A(z) 0-ik Fibonacci szm: 0
A(z) 1-ik Fibonacci szm: 1
A(z) 2-ik Fibonacci szm: 1
A(z) 3-ik Fibonacci szm: 2
A(z) 4-ik Fibonacci szm: 3
A(z) 5-ik Fibonacci szm: 5
A(z) 6-ik Fibonacci szm: 8

A(z) tc076.dat file tartalma visszafel olvasva:
8 5 3 2 1 1 0
*/
