// Program TC077-2.cpp                              (a TC077-1 alapjn)
//---------------------------------------------------------------------
// File msols, nyomtats
//   --> File megnyits konstruktor fggvnnyel
//.....................................................................
// Hasznlata: tc077-2 <forrs file> <cl file>
// Funkcija:
//    A mr ltez forrs file-t a cl file-ba msolja.
//    Ha a cl file mr ltezik, akkor azt fellrja, ha nem ltezik,
//    akkor pedig ltrehozza (feltve, hogy az lehetsges).
//    Ha a file-knt a con standard file nevet hasznljuk,
//    akkor inputknt a klaviatrt, outputknt a kpernyt jelli ki.
//    Ha szveges file nyomtatsra akarjuk hasznlni,
//    akkor cl file-knt prn-t, lpt1-et, vagy lpt2-t adjunk meg.
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.17.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // for cin, cout
#include <process.h>    // for exit()
#include <fstream.h>    // for ifstream, ofstream
//--------------------------------------------------------------

//***********************************************************************
void main( int argc, char* argv[] )
//***********************************************************************
{
 char         ch;                       // A msols munkavltozja

 if ( argc != 3 )
   { cerr << "Hasznlata " << endl;
     cerr << "  file msolshoz :  tc077-2 file1 file2"          << endl;
     cerr << "  nyomtatshoz    :  tc077-2 file1 prn/lpt1/lpt2"  << endl;
     cerr << "  line-editorknt :  tc077-2 con file"             << endl;
     cerr << "      ekkor file lezrs: ctrl-Z, Enter"           << endl;
     cerr << "  kpernyre rs :  tc077-2 file con"             << endl;
     exit(-1);
   }

 // Ltrehozzuk az ifstream input, s az ofstream output file-objektum
 // tpusokat, de ezttal a konstruktor fggvnyeikkel nyitjuk meg.
 // Termszetesen ekkor is az ifstream tpus file megnyitsa automati-
 // kusan "olvass", az ofstream tpus pedig "rs".
 ifstream     source( argv[1], ios::nocreate );
    // A nocreate hasznlata megnyitsi hibt eredmnyez, ha a megadott
    // file nem ltezik.
 if ( ! source )            // A megnyits ellenrzse
   // A cerr a szabvnyos hibakimenet (alaprtelemzsben a kperny)
   { cerr << "Nem nyithat meg a(z) " << argv[1] <<
             " forrs file olvassra\n";
     exit(-1);
   }

 ofstream     dest( argv[2] );
    // A cl file-t ltrehozza, ha nem ltezik, egybknt pedig fellrja.
 if ( ! dest )             // A megnyits ellenrzse
   { cerr << "Nem nyithat meg a(z) " << argv[2] <<
             " forrs file rsra\n";
     exit(-1);
   }

 // FILE MSOLS/NYOMTATS
 while ( dest && source.get(ch) )  dest.put(ch);

 // Mindkt file bezrsa
 source.close();
 dest.close();
} //main
