// Program TC079.cpp
//---------------------------------------------------------------------
// Elemi adatbzis-kezels
//---------------------------------------------------------------------
// Ksztsen hallgati nyilvntartst, mely a felhasznltl bekri a
// a hallgatok adatait, majd azokat egy, a felhasznl ltal megadott
// nev file-ba menti. Az adatbevitel mindaddig tart, amg a felhasznl
// azt folytatni nem kvnja.
// A program rendelkezzen egy menvel, mely az adatbevitelen kvl
// lehetsget ad listzsra, valamint kijellt hallgatknak a file-bl
// val logikai s fizikai trlsre is.
// A hallgat keress alstring szerint trtnjen.
//.....................................................................
// Lsd e program egyszerstett vltozatt (TC074.cpp)!
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.16.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <fstream.h>    // fstream, open, eof, write, read
#include <iostream.h>   // cin, cout
#include <iomanip.h>    // setf, precision
#include <conio.h>      // clrscr
#include <ctype.h>      // toupper
#include <stdlib.h>     // exit
#include <string.h>     // strcpy, strcmp, strstr
#include <stdio.h>      // remove, rename
//--------------------------------------------------------------

//--------------------------------------
// Globlis azonostk
//......................................
const int           MAXNEV = 20; // A leghosszabb nv hossza + 1
const int           MAXTXT = 50; // A leghosszabb szveg hossza + 1

typedef enum        {IGEN, NEM }  logikai;
typedef char        txt_tipus[MAXTXT];
typedef char        fnev_tipus[MAXNEV];
typedef char        nev_tipus[MAXNEV];
typedef struct      hallgato_tipus
          { logikai    torolve;  // ha torolve=IGEN, akkor a struktra
            nev_tipus  neve;     // trlend (azaz logikailag trlt)
            int        szul_eve;
            float      atlaga;
          }; // hallgato_tipus
//--------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void clrbuf();
    logikai valasz( txt_tipus );
    void varakozik();
    void menu( fstream&, fnev_tipus );
      void beir( fstream&,fnev_tipus );
      void listaz( fstream&, fnev_tipus );
        void kiolvas( hallgato_tipus );
      void log_torol( fstream&, fnev_tipus );
//      void kiolvas( hallgato_tipus );
      void fiz_torol( fstream&, fnev_tipus );
//-------------------------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void clrbuf()  { while (cin.get() != '\n'); }


logikai valasz( txt_tipus    szoveg )
// Folytatsi ignyt bekr fggvny
{
  char    kar;

  do { cout << szoveg;  cin >> kar;  clrbuf();
       kar = toupper(kar);
     } while ( kar != 'I' && kar != 'N' );
  switch ( kar )
    { case 'I' : return IGEN;
      case 'N' : return NEM;
    }
} //valasz


void varakozik()
// Egy billentyletsre vr
{
  cout << "                         ssn le egy billentyt...";
  cin.get();
} //varakozik


void beir( fstream&      tankor,
           fnev_tipus    tnev)
{
  hallgato_tipus    hallgato;
  txt_tipus         szoveg;

  // Megnyitsi kisrlet hozzrsra.
  // (Ha a file nem ltezik, akkor nem engedlyezi a hozzrsra
  // val megnyitst.)
  tankor.open( tnev, ios::binary | ios::nocreate | ios::app );
  if ( ! tankor )                       // file-megnyits hibavizsglata
    // Ha nem ltezett a file, akkor outputra prbljuk megnyitni
    { tankor.open( tnev, ios::binary | ios::out );
      if ( ! tankor )                   // file-megnyits hibavizsglata
        { cout << "Sikertelen a(z)" << tnev << " file megnyitsa!"
               << endl;
          exit(1);
        }
    }
  // A hallgato adatainak bekrse a klaviatrrl
  strcpy( szoveg, "      Folytatja? (I/N) " );
  do { hallgato.torolve = NEM;          // nem trlend
       cout << "A hallgat neve:       ";
       cin.getline( hallgato.neve, sizeof(hallgato.neve) );
       if( cin.gcount() >= sizeof(hallgato.neve)-1 )     clrbuf();
       cout << "   szletsi ve:      ";
       cin >> hallgato.szul_eve;                         clrbuf();
       cout << "   tanulmnyi tlaga:  ";
       cin >> hallgato.atlaga;                           clrbuf();
       tankor.write( (char*)&hallgato, sizeof(hallgato) );
     } while( valasz( szoveg ) == IGEN );
   tankor.close();
} //beir


void kiolvas( hallgato_tipus     hallgato )
// Egy hallgat adatainak kiolvassa a memribl a kpernyre.
{
  cout << "A hallgat neve:       " << hallgato.neve     << endl;
  cout << "   szletsi ve:      " << hallgato.szul_eve << endl;
  cout.setf(ios::fixed);
  cout.precision(2);
  cout.setf(ios::showpoint);
  cout << "   tanulmnyi tlaga:  " << hallgato.atlaga   << endl;
  if ( hallgato.torolve == IGEN )
    cout << "   trlsi llapota:   Trlt!" << endl;
  else
    cout << "   trlsi llapota:   nem trlt" << endl;
} //kiolvas


void listaz( fstream&      tankor,
             fnev_tipus    tnev)
// Adatbeolvass a file-bl, adatkirs a kpernyre
{
  hallgato_tipus     diak;

  tankor.open( tnev, ios::binary | ios::in );
  if ( ! tankor )              // fjl megnyits hibavizsglata
   { cout << "Sikertelen a(z)" << tnev << " file megnyitsa!" << endl;
     exit(2);
   }
  cout << "A(z) " << tnev << " file-beli hallgatk: " << endl << endl;
  //     Elreolvass
  tankor.read( (char*)&diak, sizeof(diak) );
  //     Ciklikus file-vg ellenrzs
  while ( ! tankor.eof() )
    { // Adatfeldolgozs (kirats a kpernyre)
      kiolvas( diak );
      cout << endl;
      // Ujraolvass
      tankor.read( (char*)&diak, sizeof(diak) );
    }
  cout << endl;
  tankor.close();
  varakozik();
} //listaz

void log_torol(fstream&       tankor,
               fnev_tipus     tnev)
// Logikai adattrls.
// Ennek sorn a trlend hallgat "torolve" adatmezjbe egy 'I'
// karaktert runk.
{
  nev_tipus         keresett_diak ;
  long int          pozicio;
  hallgato_tipus    diak;
  txt_tipus         szoveg;
  int               egyezo;
  logikai           volt_valtoztatas;

  // Az adatfile megnyitsa rsra s olvassra
  tankor.open( tnev, ios::binary | ios::in | ios::out );
  if ( ! tankor )         // a file-megnyits hibavizsglata
    { cout << "Sikertelen a(z)" << tnev << " file megnyitsa!" << endl;
      exit(3);
    }
  cout << " A keresett hallgat neve: ";
  cin.getline( keresett_diak , sizeof(keresett_diak ) );
  if ( cin.gcount() >= sizeof(keresett_diak )-1 )       clrbuf();

  volt_valtoztatas = NEM;
  tankor.read( (char*)&diak, sizeof(diak) );
  while ( ! tankor.eof() )
    { // Keressk a dikot
      // 1. Pontos keress:
      //    if ( strcmp( diak.neve, keresett_diak  ) == 0 )
      // 2. Alstring szerinti keress:
      //    if ( strstr( diak.neve, keresett_diak ) != NULL )
      if ( strstr( diak.neve, keresett_diak ) != NULL )
        // Ekkor sikerlt a keresett dikot megtallni
          { cout << endl; kiolvas( diak ); cout << endl;
            strcpy(szoveg,"Megvltoztatja a trlsi llapott? (I/N) ");
            if ( valasz( szoveg ) == IGEN )
              { // Logikai trls, azaz fizikai trlsre kijells:
                if ( diak.torolve == IGEN )
                  diak.torolve = NEM;
                else
                  diak.torolve = IGEN;
                volt_valtoztatas = IGEN;
                // Lekrdezzk az input mutatt,
                // majd kiszmtjuk a mdostand rekord pozcijt:
                pozicio = tankor.tellg() - sizeof(diak);
                // Ezutn az output mutatt idelltjuk:
                tankor.seekp( pozicio ) ;
                // azrt, hogy a mdositott struktrt az eredeti
                // helyre rhassuk vissza:
                tankor.write( (char*)&diak, sizeof(diak) );
                // Vgl az input mutatt is a mdostott struktra
                // pozcijra lltjuk:
                tankor.seekg( pozicio );
                // annak rdekben, hogy a mdostst ellenrizhessk:
                cout << endl; kiolvas( diak ); varakozik();
                // A sikeres trls/visszallts utn kiugrs a cilusbl
                break;
              }
          };
      // Ha mg nem tallta meg a keresett hallgatt,
      // akkor keresse tovbb
      tankor.read( (char*)&diak, sizeof(diak) );
    }
  if ( volt_valtoztatas == NEM )
    { cout << endl << "Nem trtnt vltoztats!" << endl;
      varakozik();
    }
  tankor.close();
} //log_torol

void fiz_torol( fstream&       tankor,
                fnev_tipus     tnev)
// Fizikai adattrls.
// tmsolja egy segdfile-ba a nem trlend (azaz logikailag nem
// trlt) adatokat, az eredeti file-t kitrli (remove), a segdfile-t
// pedig tnevezi (rename) az eredeti file nevre.
{
  fstream          seged;
  fnev_tipus       snev;
  hallgato_tipus   diak;
  int              ellenor;

  tankor.open( tnev, ios::binary | ios::in);
  if ( ! tankor )         // a file-megnyits hibavizsglata
    { cout << "Sikertelen a(z)" << tnev << " file megnyitsa!" << endl;
      exit(3);
    }
  strcpy( snev, "TEMPOR");
  seged.open( snev, ios::binary | ios::out);
  if ( ! seged )         // a file-megnyits hibavizsglata
    { cout << "Sikertelen a(z)" << snev << " file megnyitsa!" << endl;
      exit(4);
    }
  // A dikokat beolvassa a tankor file-bl, s a trlendk kivtelvel
  // kirja a segdfile-ba.
  tankor.read( (char*)&diak, sizeof(diak) );
  while ( ! tankor.eof() )
    { if ( diak.torolve == NEM )
        seged.write( (char*)&diak, sizeof(diak) );
      tankor.read( (char*)&diak, sizeof(diak) );
    }
  tankor.close();
  seged.close();

  // Az eredeti adatfile trlse
  ellenor = remove( tnev );
  if ( ellenor != 0 )
    { cout << "Nem sikerlt a(z)" << tnev << " file-t trlni!" << endl;
      exit(5);
    }

  // A segdfile tnevezse eredeti adatfile nevre
  ellenor = rename( snev, tnev );
  if ( ellenor != 0 )
    { cout << "Nem sikerlt a(z)" << snev << " file-t tnevezni!" << endl;
      exit(6);
    }

  // Ekkor sikeresen befejezdtek a fizikai trlshez kapcsold
  // mveletek.
  cout << "Sikeres volt a fizikai trls!" << endl;  varakozik();
} //fiz_torol


void menu( fstream&       tankor,
           fnev_tipus     tnev )
{
  char     valasztas;

  do { clrscr();
       cout << "                        MEN " << endl << endl;
       cout << "          Adatfile feltltse .......... A" << endl;
       cout << "          Trls / visszallts........ T" << endl;
       cout << "          Fizikai trls ............... F" << endl;
       cout << "          Listzs ..................... L" << endl;
       cout << "          Kilps ...................... K" << endl;
       cout << endl << "                             Vlasszon : ";
       cin >> valasztas;  clrbuf();
       valasztas = toupper( valasztas );
       switch ( valasztas )
          { case 'A':  beir( tankor, tnev );         break;
            case 'T':  log_torol( tankor, tnev );    break;
            case 'F':  fiz_torol( tankor, tnev );    break;
            case 'L':  listaz( tankor, tnev );       break;
            case 'K':  exit(0);
          }
       // Vgtelen ciklus, kilps csak a "K" vlasztsra
     } while ( 1==1 );
 }


/**********/
void main()
/**********/
{
  fnev_tipus      tnev;
  fstream         tankor;  // az adatfile-objektum ltrehozsa

  // Az adatfile nevnek bekrse
  clrscr();
  
  // File nv bekrs:
  cout << "Az adatfile neve: ";  cin >> tnev;  clrbuf();
  // File nv megads:
  // strcpy( tnev, "C:\\VILSZAK\\V42-tk.dat" );

  menu( tankor, tnev );
} //main
