// Program TC082.CPP                                         (Rajz3.cpp)
//----------------------------------------------------------------------
// Grafikai demo program
//  - sikidom ( Hromszg rajzolsa s befestse)
//  - mozgs szimullsa
//  - szvegkirs grafikus zemmdban
//----------------------------------------------------------------------
// A fejleszt krnyezet belltsai:
//   Option/Compiler/Entry/DOS-Standard: (.)
//   Option/Linker/Libraries/Graphics libraries: [x]
//---------------------------------------------------------------------
// Az utols javts dtuma: 2000.05.10.
//---------------------------------------------------------------------

//--------------------------------------------------------------
// A hivatkozott deklarcis file-ok
//..............................................................
#include <iostream.h>   // cin, cout
#include <graphics.h>   // grafikus fggvnyek 
#include <stdlib.h>     // exit
#include <dos.h>        // delay
#include <string.h>     // strcpy
//--------------------------------------------------------------

//------------------------------------------------------
// E modul fggvnystruktrja (prototipus modell)
//......................................................
//void main();
    void grkezd();
    void rajzol();
    void grvege();
//------------------------------------------------------

//--------------------------------
//     A fggvny defincik
//--------------------------------

void grkezd()
//----------------------------------------------------------------------
// inicializlja a grafikus rendszert, a hardvert grafikus mdba helyezi
//----------------------------------------------------------------------
{
  int         gd = DETECT;
  int         gm, errorcode;
  char        utvonal[20];

  // cout << "Krem az egabgvi file elrsi utjt: ";  cin >> utvonal;
  strcpy(utvonal, "C:\\TC3\\BGI");
  initgraph(&gd, &gm, utvonal);
   
  errorcode = graphresult();
  if (errorcode != grOk)      // hibavizsglat
    { cout << "Graphikus hiba: "<< grapherrormsg( errorcode );
      exit(1);                 // a hibakddal tr vissza
    }  
} //grkezd


void rajzol()
//-----------------------------------------------------------------
// Feliratoz.
// A mozgs irnyt kijelli egy befestett hromszggel, s egy
// befestett tglalapot vzszintesen mozgat.
//------------------------------------------------------------------
{
  char    szov[] = "Mozgs szimullsa";
  int     i;

  setcolor(MAGENTA);           // rajzol szn bellts
  line(30,100,30,150);         // vonal rajzols
  line(30,150,80,125);         // vonal rajzols
  line(30,100,80,125);         // vonal rajzols
  floodfill(35,110,MAGENTA);   // befesti az adott szn vonallal
                               // hatrolt zrt terletet

  setcolor(DARKGRAY);          // rajzolszn bellts
  moveto(80,50) ;              // a kurzort az x,y pontba mozgatja
  settextstyle(DEFAULT_FONT,HORIZ_DIR,3);
                               // szvegstlus:alaprtelmezett karakter,
                               // vzszintes irny, hromszoros mret
  outtext(szov);               // szveg kirs

  setbkcolor(LIGHTGREEN);      // httrsznbellts

  for (i = 0 ; i <= 360; i = i + 30)
    {
      setcolor(RED) ;           // rajzolszn bellts
      setfillstyle(SOLID_FILL,RED);
                                // egyenletes kitlts piros sznnel
      bar (100+i,100, 150+i, 220);
                                // kitlttt tglalap rajzols:
                                // bal fels pont koordinti,
                                // jobb als pont koordinti
      delay(200);               // vrakozs
      setcolor(LIGHTBLUE);      // rajzol szn a httrszn
      setfillstyle(EMPTY_FILL,LIGHTBLUE);
                                // kitlts res, httrsznnel
      bar (100+i,100, 150+i, 210);
                                // kitlttt tglalap rajzols
      delay(200);               // vrakozs
    }
  delay(3000);
} //rajzol


void grvege()
//------------------------------------------------------------------------
// Lezrja a grafikus rendszert
//------------------------------------------------------------------------
{
  closegraph();
} //grvege


/**********/
void main()
/**********/
{
  grkezd();                 // grafikus inicializls
  rajzol();                 // rajzol fggvny
  grvege();                 // grafikus rendszer lezrsa
} //main
