/* INVERZ.H */

/*  Inverz mtrix szmitsa LU dekompozicival */

const int maxelem=20;
typedef double tombi[maxelem+1][maxelem+2];
typedef double vekt[maxelem+1];
typedef char ftnev[20];
char menti;
fstream datafilei;

void olvas(tombi a, tombi e, int n);
void eredmeny(tombi a, tombi e, int d, int n);
void matrixkiir(tombi a, int n);
void sorcsere(tombi a, tombi e, int xm, int k, int n);
void foelem(tombi a, tombi e, int n, int k, int *d);
void dekompf(tombi a, tombi e, int n,int *d);
void yvektor(vekt y,tombi a, int n);
void xvektor(vekt x, vekt y, tombi a, int n);
void inverz(tombi a, tombi e, int n);
double det(tombi a, int n, int d);
void hangi();

void hangi()
{
        sound(1000);
        delay(30);
        sound(500);
        delay(30);
        nosound();
}


void invertal()
{
int fileerri=0;
int  n,d=1;
tombi a,e;
ftnev fnevi;

   _fpreset();

 do{
  gotoxy(3,2);
  cputs("Kvnja majd az adatokat menteni? (I/N)\n");
    do{
        menti=getch();
        hangi();
        menti=toupper(menti);
    }while((menti!='I') && (menti!='N'));
    if (menti=='I')
    {
        gotoxy(3,3);
        cputs("Krem adja meg a file nevt az elrsi ttal egytt! ");
        gotoxy(3,4);
        cin>>fnevi;
        hangi();
        clrbufg();
        datafilei.open(fnevi,ios::out);
        if(datafilei.fail())
        {
          cputs("A file mvelet nem sikerlt!");
          fileerri=1;
          getch();
          hangi();
        }

     }
}while(fileerri==1);


   cout<<endl<<endl;
   window(1,1,80,25);
   textbackground(1);
   clrscr();
   do {
       cout<<endl;
       cout<<"Elemek szma [max. 20]: ";
       cin>>n;
       datafilei<<"Elemek szma : "<<n<<endl;
   }while (n>maxelem);

   olvas(a,e,n);
   cout<<endl;
   cout<<"A mtrix ";
   datafilei<<"A mtrix "<<endl<<endl;
   cout<<endl<<endl;
   matrixkiir(a,n);
   dekompf(a,e,n,&d);
   eredmeny(a,e,d,n);
   if (menti=='I') datafilei.close();
   getch();
   hangi();
}

void olvas(tombi a,tombi e, int n)
{
 int i,j;

  cout<<endl;
  for (i=1;i<=n;i++)
  {
    for (j=1;j<=n;j++)
    {
      cout<<"a["<<i<<","<<j<<"]= "; cin>>a[i][j];
      if (menti=='I') datafilei<<"a["<<i<<","<<j<<"]= "<<a[i][j]<<endl;
      if (i==j)
      {
        e[i][j]=1.0;
      }
      else
      {
        e[i][j]=0.0;
      }
    }
    cout<<endl;
    if (menti=='I') datafilei<<endl;
  }

}
/* Az eredmnyek kiiratsa */
void eredmeny(tombi a,tombi e,int d,int n)
{

   cout<<endl;
   cout<<"Az inverz mtrix:";
   if (menti=='I') datafilei<<endl<<"Az inverz mtrix:"<<endl<<endl;
   cout<<endl<<endl;
   inverz(a,e,n);
   cout<<endl;
   cout<<"A determinns:"<<det(a,n,d)<<endl;
   if (menti=='I') datafilei<<endl<<"A determinns:"<<det(a,n,d)<<endl;
}

void matrixkiir(tombi a,int n)
{
  int i,j;
  for (i=1;i<=n;i++)
  {
    for (j=1;j<=n;j++)
    {
      setw(13);
      setprecision(4);
      cout.setf(ios::fixed);
      cout.setf(ios::right);
      cout.setf(ios::scientific);
      cout<<a[i][j]<<"  ";
      datafilei.setf(ios::fixed);
      datafilei.setf(ios::right);
      datafilei.setf(ios::scientific);
      if (menti=='I') datafilei<<a[i][j]<<"  ";
    }
     cout<<endl;
     if (menti=='I') datafilei<<endl;
  }
}

/* A mtrix sorainak felcserlse  */
void sorcsere(tombi a,tombi e,int xm,int k,int n)
{
  int i;
  double c;
  for (i=1;i<=n;i++)
  {
    c=a[xm][i]; a[xm][i]=a[k][i]; a[k][i]=c;
    c=e[xm][i]; e[xm][i]=e[k][i]; e[k][i]=c;
  }
}

/* A felem kivlasztsa */
void foelem(tombi a,tombi e,int n,int k,int *d)
{
  int i,xm;
  double am;
  am=a[k][k];xm=k;
  for (i=k;i<=n;i++)
  {
    if (fabs(am)<fabs(a[i][k]))
    {
      am=a[i][k];xm=i;
      sorcsere(a,e,xm,k,n);
      *d=*d *(-1);
    }
  }
}

/* dekompozici vgrehajtsa felem kivlasztsval */
void dekompf(tombi a,tombi e,int n,int *d)
{
 int i,j,k;

   *d = 1;
   for (k=1;k<n;k++)
   {
      foelem(a,e,n,k,d);
      cout<<endl;
      cout<<k<<". talaktott Oszt: ";
      if (menti=='I') datafilei<<endl<<k<<". talaktott Oszt: "<<endl;
      setw(13);
      setprecision(4);
      cout.setf(ios::scientific);
      cout.setf(ios::right);
      cout.setf(ios::showpoint);
      cout<<a[k][k]<<endl<<endl;
      datafilei.setf(ios::scientific);
      datafilei.setf(ios::right);
      datafilei.setf(ios::showpoint);
      if (menti=='I') datafilei<<endl<<a[k][k]<<endl<<endl;
      for (i=k+1;i<=n;i++)
      {
         a[i][k]=a[i][k]/a[k][k];
         for (j=k+1;j<=n;j++)
         {
           a[i][j]=a[i][j]-a[i][k]*a[k][j];
         }
      }
      matrixkiir(a,n);
   }
}

/*  Ly = b egyenlet megoldsa */
void yvektor(vekt y,tombi a,int n)
{
  int j,k;
  y[1]=a[1][n+1];
  for (k=2;k<=n;k++)
  {
    y[k]=0;
    for (j=1;j<=k-1;j++)
    {
      y[k]=y[k]-a[k][j]*y[j];
    }
    y[k]=y[k]+a[k][n+1];
  }
}

/*  U x = y egyenlet megoldsa */
void xvektor(vekt x,vekt y,tombi a,int n)
{
  int j,k;
    x[n]=y[n]/a[n][n];
    for (k=n-1;k>=1;k--)
    {
      x[k]=0;
      for (j=k+1;j<=n;j++)
      {
        x[k]=x[k]-a[k][j]*x[j];
      }
      x[k]=(y[k]+x[k])/a[k][k];
    }
}

/* A mtrix inverznek kiszmitsa */
void inverz(tombi a,tombi e,int n)
{
 int i,j;
 vekt x, y;
  for (j=1;j<=n;j++)
  {
    for (i=1;i<=n;i++)
    {
      a[i][n+1]=e[i][j];
    }
    yvektor(y,a,n);
    xvektor(x,y,a,n);
    for (i=1;i<=n;i++)
    {
      e[i][j]=x[i];
    }
  }
  matrixkiir(e,n);
}

/* A determinns kiszmitsa */
double det(tombi a,int n,int d)
{
  int k;
  double c;
  c=a[1][1];
  for (k=2;k<=n;k++)
  {
    c=c*a[k][k];
  }
  return (d*c);
}




