/* Program TX014.c */
/*---------------------------------------------------------------------*/
/* Vektor elemek ciklikus lptetse (krforg puffer hasznlata).      */
/* (Globlis konstans s tpus, rtk- s cmparamterek alkalmazsa)  */
/*---------------------------------------------------------------------*/
/* Az utols javts dtuma: 2000.02.27.                               */
/*---------------------------------------------------------------------*/
/*--------------------------------------------------------------*/
/* A hivatkozott deklarcis file-ok                            */
/*..............................................................*/
#include <stdio.h>    /* printf, scanf                          */
#include <conio.h>    /* getche                                 */
#include <math.h>     /* floor, abs                             */
#include <ctype.h>    /* toupper                                */
/*--------------------------------------------------------------*/

/*----------------------------*/
/* A program modulstruktrja */
/*............................*/
/* TCx14.cpp                  */
/*----------------------------*/

/*--------------------------------------*/
/* Globlis azonostk                  */
/*......................................*/
const int       VHOSSZ = 5;             /* A vektormret definilsa */
typedef char    vektortipus[VHOSSZ];    /* A vektortpus definilsa */
/*--------------------------------------*/

/*------------------------------------------------------*/
/* E modul fggvnystruktrja (prototipusok)           */
/*......................................................*/
void main(void);
  void feltolt(vektortipus&);
  void kiir(vektortipus&);
  void forgatkiir(vektortipus&);
    int mod(int, int);
    int lepeskerdes(void);
    void forgat(int, vektortipus&);
      void pozitivforgatas(int, vektortipus&);
      void negativforgatas(int, vektortipus&);
//  void kiir(vektortipus&);
/*------------------------------------------------------*/

int mod(int   a,
        int   b)
/* Az a s b egsz osztsnak maradkt adja vissza. */
{
  int       maradek;
  maradek = a - floor(a/b) * b ;
  return maradek;
}

void feltolt(vektortipus&   avektor)
/* Vektorfeltlts */
{
  int       index;
  for (index = 0; index <= (VHOSSZ-1); index = index+1)
     {
      printf("A vektor %d-ik karaktere:", index);
      scanf("%1s", &avektor[index]);
     }
  printf("\n");
} /* Feltolt */

void kiir(vektortipus&   hvektor)
 /* A vektor kiratsa */
{
  int       index;
  for (index = 0; index <= (VHOSSZ-1); index = index+1)
    printf("%1c", hvektor[index]);
  printf("\n");
} /* Kiir */

int lepeskerdes()
{
  int       valasz ;
  printf("Mennyit lptet?  (pozitv-negatv szmot egyarnt megadhat) : ");
  scanf("%d", &valasz);
  return valasz ;
} /* lepeskerdes */

void pozitivforgatas(int            lepes,
                     vektortipus&   dvektor)
{
  int       lindex, index;
  char      atmenet;
  for (lindex = 1; lindex <= lepes; lindex = lindex+1)
    {
     atmenet = dvektor[VHOSSZ-1];
     for (index = (VHOSSZ-1); index >= 1; index = index-1)
       dvektor[index] = dvektor[index-1];
     dvektor[0] = atmenet;
    }
} /* pozitivforgatas */

void negativforgatas(int            lepes,
                     vektortipus&   evektor)
{
  pozitivforgatas(VHOSSZ-lepes, evektor);
} /* negativforgatas */

void forgat(int            lepesszam,
            vektortipus&   cvektor)
{
  if (lepesszam >= 0)
    pozitivforgatas(lepesszam, cvektor);
  else
    negativforgatas(abs(lepesszam), cvektor);
} /*  forgat */

void forgatkiir(vektortipus&   bvektor)
{
  char      folytatja;
  int       lepesszam;
  do {
      lepesszam = mod(lepeskerdes(), VHOSSZ);
      forgat(lepesszam, bvektor);
      kiir(bvektor);
      do {
          printf("Folytatja? (I/N) : ");
          folytatja = getche(); printf("\n");
          folytatja = toupper(folytatja);
         } while(!(folytatja == 'I' || folytatja == 'N'));
     } while (folytatja != 'N');
} /* forgatkiir */

void main()  /* A fprogram */
{
  vektortipus     xvektor;

  /*  Vektorfeltlts */
  feltolt(xvektor);

  /* A bert vektor kiratsa */
  kiir(xvektor);

  /* A vektor ciklikus lptetse (forgatsa), s kiiratsa */
  forgatkiir(xvektor);
}

/*
A program futtatsa:
--------------------

A vektor 1-ik karaktere: U
A vektor 2-ik karaktere: V
A vektor 3-ik karaktere: W
A vektor 4-ik karaktere: X
A vektor 5-ik karaktere: Y
UVWXY
Mennyit lptet? (pozitv-negatv szmot egyarnt megadhat) : 3
WXYUV
Folytatja? (I/N) : i
Mennyit lptet? (pozitv-negatv szmot egyarnt megadhat) : -8
UVWXY
Folytatja? (I/N) : n
*/
